﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.IO;

namespace Algoritmi_CSI
{
    public partial class FormCezarCriptare : Form
    {
        public FormCezarCriptare()
        {
            InitializeComponent();
        }

        public char[] sep = { ' ', ',', '.', ';', '(', ')', '_', '+', '-', '=', '{', '}', '[', ']', ':', '<', '>',
            '~', '`', '"', '/', '*', '?', '!', '@', '#', '$', '%', '^', '&', '*'};

        public bool EsteLitera(string inputString)
        {
            string[] cif = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
            for (int i = 0; i < cif.Length; i++)
                if (inputString.Contains(cif[i]))
                    return false;
            return true;
        }

        private string Verificare(string textPT)
        {
            //se verifica daca sirul dorit pentru a fi criptat este alcatuit corect
            string[] textPTM = new string[textPT.Length];

            if (string.IsNullOrEmpty(textPT))
                MessageBox.Show("Nu ati introdus un sir pentru a putea fi realizata criptarea!");
            else if (!EsteLitera(textPT))
            {
                MessageBox.Show("Sirul introdus pentru criptare nu trebuie sa contina cifre!");
            }
            else
                textPTM = textPT.ToUpper().Split(sep);

            string sir = "";
            for (int i = 0; i < textPTM.Length; i++)
                sir += textPTM[i];

            textPT = Regex.Replace(sir, @"\t|\n|\r", "");
            return textPT;
        }

        private string Verificare2(string textN)
        {
            //se verifica daca pasul dorit pentru a realiza criptarea este alcatuit corect
            string[] textNM = new string[textN.Length];

            if (string.IsNullOrEmpty(textN))
                MessageBox.Show("Nu ati introdus pasul (numarul) cu sa se poata realiza criptarea!");
            else if (EsteLitera(textN))
            {
                MessageBox.Show("Pasul (numarul) introdus pentru criptare trebuie sa contina cifre!");
            }
            else
                textNM = textN.ToUpper().Split(sep);

            string sir = "";
            for (int i = 0; i < textNM.Length; i++)
                sir += textNM[i];

            textN = Regex.Replace(sir, @"\t|\n|\r", "");
            return textN;
        }

        private string Criptare(string text, int cifN)
        {
            string sir = Verificare(txtPT.Text);

            byte[] PTbytes = Encoding.ASCII.GetBytes(sir);
            cifN = int.Parse(txtN.Text);

            try
            {
                foreach (byte b in PTbytes)
                {                    
                    int adun = b + cifN; //se aduna byte-ul din PT cu byte-ul lui N                    
                    if (adun > 90) //se verifica daca se ajunge la Z
                        adun -= 26; //se reia de la inceput
                    char ch = Convert.ToChar(adun);
                    txtCT.Text += ch.ToString();                    
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Gresit! - EROARE!");
            }
            return txtCT.Text;
        }

        private void btnCripteaza_Click(object sender, EventArgs e)
        {
            txtCT.Text = "";
            txtN.Text = Verificare2(txtN.Text);
            txtPT.Text = Verificare(txtPT.Text);
            txtCT.Text = Criptare(txtPT.Text, int.Parse(txtN.Text));
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Title = "Open File";
            open.Filter = "Text Files (*.txt)|*.txt| All Files (*.*)|*.*";

            if(open.ShowDialog()==DialogResult.OK)
            {
                StreamReader read = new StreamReader(File.OpenRead(open.FileName));

                txtPT.Text = read.ReadToEnd();
                read.Dispose();
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveFileDialog save = new SaveFileDialog();
            save.Title = "Save File";
            save.Filter = "Text Files (*.txt)|*.txt| All Files (*.*)|*.*";

            if(save.ShowDialog()==System.Windows.Forms.DialogResult.OK)
            {
                StreamWriter write = new StreamWriter(File.Create(save.FileName));

                write.Write(txtCT.Text);
                write.Dispose();
            }
        }
    }
}
