﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.IO;

namespace Algoritmi_CSI
{
    public partial class FormPlayfairDecriptare : Form
    {
        public FormPlayfairDecriptare()
        {
            InitializeComponent();
        }

        public char[] sep = { ' ', ',', '.', ';', '(', ')', '_', '+', '-', '=', '{', '}', '[', ']', ':', '<', '>',
            '~', '`', '"', '/', '*', '?', '!', '@', '#', '$', '%', '^', '&', '*'};

        public bool EsteLitera(string inputString)
        {
            string[] cif = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
            for (int i = 0; i < cif.Length; i++)
                if (inputString.Contains(cif[i]))
                    return false;
            return true;
        }

        private string Verificare(string textCT)
        {            
            string[] textCTM = new string[textCT.Length];

            if (string.IsNullOrEmpty(textCT))
                MessageBox.Show("Nu ati introdus un sir pentru a putea fi realizata criptarea!");
            else if (!EsteLitera(textCT))
            {
                MessageBox.Show("Sirul introdus pentru criptare nu trebuie sa contina cifre!");
                txtCT.Text = "";
            }
            else
                textCTM = textCT.ToUpper().Split(sep);

            string sir = "";
            for (int i = 0; i < textCTM.Length; i++)
                sir += textCTM[i];

            if (sir.Contains('J'))
                sir = sir.Replace('J', 'I'); //inlocuirea aparitiile lui J cu I

            textCT = Regex.Replace(sir, @"\t|\n|\r", "");
            return textCT;
        }

        private void btnDecripteaza_Click(object sender, EventArgs e)
        {
            txtKey.Text = AranjareCheie(txtKey.Text);
            txtCT.Text = Verificare(txtCT.Text);
            txtPT.Text = Decriptare(txtCT.Text, txtKey.Text);
        }

        private string AranjareCheie(string textK)
        {
            string[] textKeyM = new string[textK.Length];
            if (string.IsNullOrEmpty(textK))
                MessageBox.Show("Nu ati introdus un sir pentru a putea fi realizata criptarea!");
            else if (!EsteLitera(textK))
            {
                MessageBox.Show("Sirul introdus pentru criptare nu trebuie sa contina cifre!");
                txtKey.Text = "";
            }
            else
                textKeyM = textK.ToUpper().Split(sep);

            string key = "";
            for (int i = 0; i < textKeyM.Length; i++)
                key += textKeyM[i];

            key = new string(key.ToCharArray().Distinct().ToArray());  //se elimina dublurile din cheie
            return key;
        }

        private string[,] GenerareMatrice(string cheie)
        {
            string[,] matr = new string[5, 5];
            string alfabet = "ABCDEFGHIKLMNOPQRSTUVWXYZ";
            char[] arr = alfabet.ToCharArray();
            int i = 0, j = 0;
            string str = "";
            str += cheie;

            for (int k = 0; k < arr.Length; k++)
                if (!str.Contains(arr[k]))
                    str += arr[k].ToString();

            for (int k = 0; k < str.Length; k++)
            {
                matr[i, j] = str[k].ToString(); j++;
                if (j == 5) { j = 0; i++; }

            }
            return matr;
        }

        private string DecriptareText(int start, int inc, string text, string[,] matr)
        {
            string rez = "";
            char x, y;
            string a = ""; string b = "";
            int xcol = 0, xlin = 0, ycol = 0, ylin = 0;

            String temp = text.Substring(start, inc);
            x = temp[0];
            y = temp[1];

            if (xcol != 5)
                for (int i = 0; i < 5; i++)
                    for (int j = 0; j < 5; j++)
                        if (matr[i, j] == x.ToString())
                        {
                            xlin = i;
                            xcol = j;
                            break;
                        }

            if (ycol != 5)
                for (int i = 0; i < 5; i++)
                    for (int j = 0; j < 5; j++)
                        if (matr[i, j] == y.ToString())
                        {
                            ylin = i;
                            ycol = j;
                            break;
                        }

            if ((xcol != ycol) && (xlin != ylin)) //linii  si coloane diferite in matricea cheii
            {
                a += matr[xlin, ycol];
                b += matr[ylin, xcol];
                rez = a + b;
            }

            else if (xlin == ylin) //aceeeasi linie in matricea cheii
            {
                xcol = xcol - 1;
                ycol = ycol - 1;

                if (xcol < 0) xcol = 4;
                if (ycol < 0) ycol = 4;

                a += matr[xlin, xcol];
                b += matr[ylin, ycol];
                rez = a + b;
            }

            else if (xcol == ycol) //aceeeasi coloana in matricea cheii
            {
                xlin = xlin - 1;
                ylin = ylin - 1;

                if (xlin < 0) xlin = 4;
                if (ylin < 0) ylin = 4;

                a += matr[xlin, xcol];
                b += matr[ylin, ycol];
                rez = a + b;
            }
            return rez;
        }

        public string Decriptare(string text, string key)
        {
            string rez = "";
            string[,] matr = GenerareMatrice(key);
            int starti = 0;
            int endi = 2; //cate 2 caractere
            int increment = 2;

            while (endi <= text.Length)
            {
                rez += DecriptareText(starti, increment, text, matr);
                starti = endi;
                endi += 2;
            }
            return rez;
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Title = "Open File";
            open.Filter = "Text Files (*.txt)|*.txt| All Files (*.*)|*.*";

            if (open.ShowDialog() == DialogResult.OK)
            {
                StreamReader read = new StreamReader(File.OpenRead(open.FileName));

                txtCT.Text = read.ReadToEnd();
                read.Dispose();
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveFileDialog save = new SaveFileDialog();
            save.Title = "Save File";
            save.Filter = "Text Files (*.txt)|*.txt| All Files (*.*)|*.*";

            if (save.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamWriter write = new StreamWriter(File.Create(save.FileName));

                write.Write(txtPT.Text);
                write.Dispose();
            }
        }
    }
}
