﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;

namespace lab1
{
    public partial class Enigma : Form
    {
        public Enigma()
        {
            InitializeComponent();
        }

        public char[] sep = { ' ', ',', '.', ';', '/', '*', '?', '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+', '-', '=', '{', '}', '[', ']', ':', '<', '>', '~', '`', '"' };
        public string alfabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";


        public string[] reflectorB = { "AY", "BR", "CU", "DH", "EQ", "FS", "GL", "IP", "JX", "KN", "MO", "TZ", "VW" };
        public string[] reflectorC = { "AF", "BV", "CP", "DJ", "EI", "GO", "HY", "KR", "LZ", "MX", "NW", "TQ", "SU" };

        public string[] rotor1 = { "E", "K", "M", "F", "L", "G", "D", "Q", "V", "Z", "N", "T", "O", "W", "Y", "H", "X", "U", "S", "P", "A", "I", "B", "R", "C", "J" };
        public string[] rotor2 = { "A", "J", "D", "K", "S", "I", "R", "U", "X", "B", "L", "H", "W", "T", "M", "C", "Q", "G", "Z", "N", "P", "Y", "F", "V", "O", "E" };
        public string[] rotor3 = { "B", "D", "F", "H", "J", "L", "C", "P", "R", "T", "X", "V", "Z", "N", "Y", "E", "I", "W", "G", "A", "K", "M", "U", "S", "Q", "O" };

        public bool IsAlphabets(string inputString)
        {
            string[] cifre = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "0" };
            for (int i = 0; i < cifre.Length; i++)
                if (inputString.Contains(cifre[i]))
                    return false;
            return true;
        }

        private string PregatireText(string textPT)
        {
            //pregatire text
            string[] textPTM = new string[textPT.Length];

            if (string.IsNullOrEmpty(textPT))
                MessageBox.Show("Textul introdus pentru criptare nu trebuie sa fie vid!");
            else if (!IsAlphabets(textPT))
            {
                MessageBox.Show("Textul introdus pentru criptare nu trebuie sa contina cifre!");
                richTextBox1.Text = "";
            }
            else
                textPTM = textPT.ToUpper().Split(sep);

            string sir = "";
            for (int i = 0; i < textPTM.Length; i++)
                sir += textPTM[i];

            textPT = Regex.Replace(sir, @"\t|\n|\r", "");
            return textPT;
        }

        public string tur(string car, string[,] matrice, string[] reflector)
        {
            string refl1 = "";
            int poz1 = 0, poz2 = 0, poz3 = 0;
            string r3 = "", r2 = "", r1 = "", refl = "";

            for (int j = 0; j < matrice.GetLength(1); j++)
                if (car == alfabet[j].ToString())    //caut in alfabet
                {
                    poz3 = j;
                    r3 = matrice[3, poz3];
                    for (int k = 0; k < matrice.GetLength(1); k++)   //caut in alfabet
                        if (r3 == matrice[0, k])
                        {
                            poz2 = k;
                            r2 = matrice[2, poz2];
                            for (int l = 0; l < matrice.GetLength(1); l++) //caut in alfabet
                                if (r2 == matrice[0, l])
                                {
                                    poz1 = l;
                                    r1 = matrice[1, poz1];
                                    for (int p = 0; p < reflector.Length; p++) //caut in reflector
                                        if (reflector[p].Contains(r1))   //caut perechea
                                        {
                                            refl = reflector[p];
                                            refl1 = refl.Replace(r1, ""); //in refl1 am celalalt caracter   
                                        }
                                }
                        }
                }
            return refl1;
        }

        public string retur(string refl, string[,] matrice, string[] reflector)
        {

            int poz1 = 0, poz2 = 0, poz3 = 0;
            string r3 = "", r2 = "", r1 = "";

            for (int j = 0; j < matrice.GetLength(1); j++)
                if (refl == matrice[1, j])    //caut in r1
                {
                    poz1 = j;
                    r1 = matrice[0, poz1];
                    for (int k = 0; k < matrice.GetLength(1); k++)   //caut in r2
                        if (r1 == matrice[2, k])
                        {
                            poz2 = k;
                            r2 = matrice[0, poz2];
                            for (int l = 0; l < matrice.GetLength(1); l++) //caut in r3
                                if (r2 == matrice[3, l])
                                {
                                    poz3 = l;
                                    r3 = matrice[0, poz3];
                                }
                        }
                }
            return r3;
        }



        public string[,] CreareMatrice(string[] reflector)
        {
            string[,] matrice = new string[4, 26];

            for (int i = 0; i < alfabet.Length; i++)
            {
                matrice[0, i] = alfabet[i].ToString();
                matrice[1, i] = rotor1[i].ToString();
                matrice[2, i] = rotor2[i].ToString();
                matrice[3, i] = rotor3[i].ToString();
            }
            return matrice;
        }
        private void btnCriptare_Click(object sender, EventArgs e)
        {
            try
            {
                string[] reflector = new string[reflectorB.Length];
                richTextBox1.Text = PregatireText(richTextBox1.Text);

                if (chkRefB.Checked == true) reflector = reflectorB;
                else if (chkRefC.Checked == true) reflector = reflectorC;

                string[,] matrice = CreareMatrice(reflector);
                richTextBox2.Text = criptare(richTextBox1.Text, matrice, reflector);
            }
            catch(Exception)
            {
                MessageBox.Show("Eroare");
            }
           
        }

        public string criptare(string text, string[,] matrice, string[] reflector)
        {
            string rez = "", refl = "", partial = "";
            for (int i = 0; i < text.Length; i++)
            {
                refl = tur(text[i].ToString(), matrice, reflector);
                partial = retur(refl, matrice, reflector);
                rez += partial;
            }
            return rez;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFile = new OpenFileDialog();
            openFile.Filter = "Text Files (.txt)|*.txt|All Files (*.*)|*.*";

            if (openFile.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    System.IO.Stream fileStream = openFile.OpenFile();
                    string nume = openFile.FileName;
                    //citesc textul din fisier
                    string[] text = File.ReadAllLines(nume);
                    //pun tot textul intr-un string
                    string text_tot = string.Join("", text);//elimin spatiile
                    richTextBox1.Text = text_tot.ToString();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //scriu in fisier
            string text_final = richTextBox2.Text.ToString();
            DialogResult dialogResult = MessageBox.Show("Salvati in fisier?", "Salvare", MessageBoxButtons.YesNo);
            if (dialogResult == DialogResult.Yes)
            {
                SaveFileDialog save = new SaveFileDialog();

                save.FileName = "DefaultOutputName.txt";

                save.Filter = "Text File | *.txt";

                if (save.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter writer = new StreamWriter(save.OpenFile());
                    writer.WriteLine(text_final);
                    writer.Dispose();
                    writer.Close();
                }
                 
                richTextBox1.Text = "";
                richTextBox2.Text = "";
            }
            MessageBox.Show("Salvare efectuata cu succes!");

        }
    }
}
