﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CSI
{
    public partial class Playfair : Form
    {
        public Playfair()
        {
            InitializeComponent();
        }

        private void browseClick(object sender, EventArgs e)
        {
            OpenFileDialog openFile1 = new OpenFileDialog();
            openFile1.Filter = "Text Files|*.txt";
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                richTextBox2.LoadFile(openFile1.FileName, RichTextBoxStreamType.PlainText);
        }

        private void saveClick(object sender, EventArgs e)
        {
            SaveFileDialog saveFile1 = new SaveFileDialog();
            saveFile1.DefaultExt = "*.txt";
            saveFile1.Filter = "Text Files|*.txt";
            if (saveFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK && saveFile1.FileName.Length > 0)
            {
                richTextBox3.SaveFile(saveFile1.FileName, RichTextBoxStreamType.PlainText);
            }
        }

        private void criptareClick(object sender, EventArgs e)
        {
            if ((textBox1.Text != "") && (textBox1.Text != ""))
            {
                string output = "";
                string input = richTextBox2.Text.ToLower();
                string key = textBox1.Text.ToLower();
                string letter = "abcdefghiklmnopqrstuvwxyz";
                string grid = null;

                key = Regex.Replace(key, "", "");
                key = key.Replace('j', 'i');
                for (int i = 0; i < key.Length; i++)
                {
                    if ((grid == null) || (!grid.Contains(key[i])))
                    { grid += key[i]; }
                }

                for (int i = 0; i < letter.Length; i++)
                {
                    if (!grid.Contains(letter[i]))
                    { grid += letter[i]; }
                }

                input = Regex.Replace(input, "", "");
                input = input.Replace('j', 'i');

                for (int i = 0; i < input.Length; i += 2)
                {
                    if (((i + 1) < input.Length) && (input[i] == input[i + 1]))
                    { input = input.Insert(i + 1, "x"); }
                }
                if ((input.Length % 2) > 0)
                { input += "x"; }

                int temp = 0;
                do
                {
                    int PosA = grid.IndexOf(input[temp]);
                    int PosB = grid.IndexOf(input[temp + 1]);
                    int RowA = PosA / 5;
                    int ColA = PosA % 5;
                    int RowB = PosB / 5;
                    int ColB = PosB % 5;

                    if (ColA == ColB)
                    {
                        PosA += 5; PosB += 5;
                    }
                    else
                    {
                        if (RowA == RowB)
                        {
                            if (ColA == 4) PosA -= 4;
                            else
                            { PosA += 1; }
                            if (ColB == 4) PosB -= 4;
                            else
                            { PosB += 1; }
                        }
                        else
                        {
                            if (RowA < RowB)
                            { PosA -= ColA - ColB; PosB += ColA - ColB; }
                            else
                            { PosA += ColB - ColA; PosB -= ColB - ColA; }
                        }
                    }
                    if (PosA >= grid.Length)
                    { PosA = 0 + (PosA - grid.Length); }
                    if (PosB >= grid.Length)
                    { PosB = 0 + (PosB - grid.Length); }
                    if (PosA < 0)
                    { PosA = grid.Length + PosA; }
                    if (PosB < 0)
                    { PosB = grid.Length + PosB; }
                    output += grid[PosA].ToString() + grid[PosB].ToString();
                    temp += 2;
                } while (temp < input.Length);

                richTextBox3.Text = output;
            }
            else
            {
                MessageBox.Show("Nu ati introdus date in campuri");
            }
        }

        private void decriptareClick(object sender, EventArgs e)
        {
            if ((textBox1.Text != "") && (textBox1.Text != ""))
            {

                string output = "";
                string input = richTextBox2.Text.ToLower();
                string key = textBox1.Text.ToLower();
                string letter = "abcdefghiklmnopqrstuvwxyz";
                string grid = null;

                key = key.Replace('j', 'i');
                for (int i = 0; i < key.Length; i++)
                {
                    if ((grid == null) || (!grid.Contains(key[i])))
                    { grid += key[i]; }
                }

                for (int i = 0; i < letter.Length; i++)
                {
                    if (!grid.Contains(letter[i]))
                    { grid += letter[i]; }
                }

                int temp = 0;
                do
                {
                    int PosA = grid.IndexOf(input[temp]);
                    int PosB = grid.IndexOf(input[temp + 1]);
                    int RowA = PosA / 5;
                    int ColA = PosA % 5;
                    int RowB = PosB / 5;
                    int ColB = PosB % 5;

                    if (ColA == ColB)
                    { PosA -= 5; PosB -= 5; }
                    else
                    {
                        if (RowA == RowB)
                        {
                            if (ColA == 0) PosA += 4;
                            else
                            { PosA -= 1; }
                            if (ColB == 0) PosB += 4;
                            else
                            { PosB -= 1; }
                        }
                        else
                        {
                            if (RowA < RowB)
                            { PosA -= ColA - ColB; PosB += ColA - ColB; }
                            else
                            { PosA += ColB - ColA; PosB -= ColB - ColA; }
                        }
                    }

                    if (PosA > grid.Length)
                    { PosA = 0 + (PosA - grid.Length); }
                    if (PosB > grid.Length)
                    { PosB = 0 + (PosB - grid.Length); }
                    if (PosA < 0)
                    { PosA = grid.Length + PosA; }
                    if (PosB < 0)
                    { PosB = grid.Length + PosB; }
                    output += grid[PosA].ToString() + grid[PosB].ToString();
                    temp += 2;
                } while (temp < input.Length);

                richTextBox3.Text = output;
            }
            else
            {
                MessageBox.Show("Nu ati introdus date in campuri");
            }
        }
    }
}
