﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace csi
{
    public partial class ADFGVX_Decriptare : Form
    {
        public ADFGVX_Decriptare()
        {
            InitializeComponent();
        }
        private static Dictionary<int, string> position = new Dictionary<int, string>()
        {   {0, "A"},
            {1, "D"},
            {2, "F"},
            {3, "G"},
            {4, "V"},
            {5, "X"}
        };
        private static string[,] preCriptingTable, criptingTable;


        private static void CriptingTable(string KEY2, string T, bool encript)
        {
            int cols, t = 0;
            List<char> order = new List<char>(KEY2.Length);
            foreach (char ch in KEY2)
                order.Add(ch);
            order.Sort();
            if (encript)
            {
                cols = T.Length % KEY2.Length == 0 ? T.Length / KEY2.Length + 1 : T.Length / KEY2.Length + 2;
                criptingTable = new string[KEY2.Length, cols];
                for (int i = 0; i < cols - 1; i++)
                    for (int j = 0; j < KEY2.Length; j++)
                        try
                        {
                            criptingTable[j, i] = T[t++].ToString();
                        }
                        catch (IndexOutOfRangeException)
                        {
                            Random rnd = new Random();
                            criptingTable[j, i] = position[rnd.Next(position.Count)];
                        }
                for (int i = 0; i < KEY2.Length; i++)
                    criptingTable[KEY2.IndexOf(order[i]), cols - 1] = (i + 1).ToString();
            }
            else
            {
                cols = T.Length / KEY2.Length + 1;
                criptingTable = new string[KEY2.Length, cols];
                t = 0; 
                for (int i = 0; i < KEY2.Length; i++)
                    for (int j = 0; j < cols - 1; j++)
                    {
                        criptingTable[KEY2.IndexOf(order[i]), cols - 1] = (i + 1).ToString();
                        criptingTable[KEY2.IndexOf(order[i]), j] = T[t++].ToString();
                    }
            }
        }


        private static void PreCriptingTable(string KEY1)
        {
            int k = 0;
            preCriptingTable = new string[position.Count, position.Count];
            for (char i = 'A'; i <= 'Z'; i++)
                if (!KEY1.Contains(i))
                    KEY1 = KEY1.Insert(KEY1.Length, i.ToString());
            for (int i = 0; i <= 9; i++)
                if (!KEY1.Contains(i.ToString()))
                    KEY1 = KEY1.Insert(KEY1.Length, i.ToString());
            for (int i = 0; i < position.Count; i++)
                for (int j = 0; j < position.Count; j++)
                    preCriptingTable[i, j] = KEY1[k++].ToString();
        }

        private static string prepareTextandKeys(ref string T, ref string KEY1, ref string KEY2)
        {
            for (int i = T.Length - 1; i >= 0; i--)
            {
                if (T[i] < 'A' || T[i] > 'Z')
                {
                    T = T.Remove(i, 1);
                }
            }
            for (int i = KEY1.Length - 1; i >= 0; i--)
            {
                if ((T[i] < 'A' || T[i] > 'Z') && !char.IsDigit(T[i]))
                {
                    KEY1 = KEY1.Remove(i, 1);
                }
            }
            KEY1 = new string(KEY1.ToCharArray().Distinct().ToArray());
            for (int i = KEY2.Length - 1; i >= 0; i--)
            {
                if (KEY2[i] < 'A' || KEY2[i] > 'Z')
                {
                    KEY2 = KEY2.Remove(i, 1);
                }
            }
                return string.Empty;
        }

        internal static string decriptare(string cheia1, string cheia2, string _CT)
        {
            string KEY1 = cheia1.ToUpper();
            string KEY2 = cheia2.ToUpper();
            string CT = _CT.ToUpper();
            string PT = string.Empty;
            PT = prepareTextandKeys(ref CT, ref KEY1, ref KEY2);
            if (PT != string.Empty)
                return PT + "*";
            else
            {
                CriptingTable(KEY2, CT, false);
                int cols = criptingTable.GetLength(1);
                for (int i = 0; i < cols - 1; i++)
                    for (int j = 0; j < KEY2.Length; j++)
                        PT += criptingTable[j, i];
                CT = PT;
                PT = string.Empty;
                PreCriptingTable(KEY1);
                int posl = -1, posc = -1;
                for (int i = 0; i < CT.Length - 1; i += 2)
                {
                    foreach (KeyValuePair<int, string> pair in position)
                    {
                        if (pair.Value.Equals(CT[i].ToString()))
                            posl = pair.Key;
                        if (pair.Value.Equals(CT[i + 1].ToString()))
                            posc = pair.Key;
                    }
                    PT += preCriptingTable[posl, posc];
                }
                return PT;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (richTextBox2.Text.Equals(string.Empty) || txtCheia1.Text.Equals(string.Empty) || txtCheia2.Text.Equals(string.Empty))
            {
                MessageBox.Show("Nu ati completat campurile");
            }
            else
            {
                string message = decriptare(txtCheia1.Text, txtCheia2.Text, richTextBox2.Text);
                if (message.Contains("*"))
                {
                    richTextBox3.Text = string.Empty;
                    MessageBox.Show(message.Remove(message.Length - 1));
                }
                else
                    richTextBox3.Text = message;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFile1 = new OpenFileDialog();
            openFile1.Filter = "Text Files|*.txt";
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                richTextBox2.LoadFile(openFile1.FileName, RichTextBoxStreamType.PlainText);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFile1 = new SaveFileDialog();
            saveFile1.DefaultExt = "*.txt";
            saveFile1.Filter = "Text Files|*.txt";
            if (saveFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK && saveFile1.FileName.Length > 0)
            {
                richTextBox3.SaveFile(saveFile1.FileName, RichTextBoxStreamType.PlainText);
            }
        }
    }
}
