﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace csi
{
    public partial class Masina_Enigma : Form
    {

        #region RotorsReflectorsSettings
        private static string Rotor1 = "EKMFLGDQVZNTOWYHXUSPAIBRCJ";
        private static string Rotor2 = "AJDKSIRUXBLHWTMCQGZNPYFVOE";
        private static string Rotor3 = "BDFHJLCPRTXVZNYEIWGAKMUSQO";
        private static Dictionary<char, char> ReflectorB = new Dictionary<char, char>()
        {
            {'A', 'Y'},
            {'B', 'R'},
            {'C', 'U'},
            {'D', 'H'},
            {'E', 'Q'},
            {'F', 'S'},
            {'G', 'L'},
            {'I', 'P'},
            {'J', 'X'},
            {'K', 'N'},
            {'M', 'O'},
            {'T', 'Z'},
            {'V', 'W'}
        };
        private static Dictionary<char, char> ReflectorC = new Dictionary<char, char>()
        {
            {'A', 'F'},
            {'B', 'V'},
            {'C', 'P'},
            {'D', 'J'},
            {'E', 'I'},
            {'G', 'O'},
            {'H', 'Y'},
            {'K', 'R'},
            {'L', 'Z'},
            {'M', 'X'},
            {'N', 'W'},
            {'T', 'Q'},
            {'S', 'U'}
        };
        #endregion

        public Masina_Enigma()
        {
            InitializeComponent();
        }

        internal static string criptare(string _IT, bool reflectorB)
        {
            string IT = _IT.ToUpper();
            string OT = string.Empty;
            char ch;
            prepareInputText(ref IT);
            for (int i = 0; i < IT.Length; i++)
            {
                ch = Rotor3[((int)IT[i]) - 65];
                ch = Rotor2[(int)ch - 65];
                ch = Rotor1[(int)ch - 65];
                if (reflectorB)
                    foreach (KeyValuePair<char, char> pair in ReflectorB)
                    {
                        if (pair.Key.Equals(ch))
                            ch = pair.Value;
                        else if (pair.Value.Equals(ch))
                            ch = pair.Key;
                    }
                else
                    foreach (KeyValuePair<char, char> pair in ReflectorC)
                    {
                        if (pair.Key.Equals(ch))
                            ch = pair.Value;
                        else if (pair.Value.Equals(ch))
                            ch = pair.Key;
                    }
                ch = (char)(Rotor1.IndexOf(ch) + 65);
                ch = (char)(Rotor2.IndexOf(ch) + 65);
                ch = (char)(Rotor3.IndexOf(ch) + 65);
                OT += ch;
            }
            return OT;
        }

        private void button1_Click(object sender, EventArgs e)
        {
           
            if (richTextBox2.Text.Equals(string.Empty))
                MessageBox.Show("Completati campul");
            else
            {
                if (radioReflectorB.Checked == true)
                    richTextBox3.Text = criptare(richTextBox2.Text, true);
                else
                    richTextBox3.Text = criptare(richTextBox2.Text, false);
            }
        }

        private static void prepareInputText(ref string IT)
        {
            for (int i = IT.Length - 1; i >= 0; i--)
            {
                if (IT[i] < 'A' || IT[i] > 'Z')
                {
                    IT = IT.Remove(i, 1);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFile1 = new OpenFileDialog();
            openFile1.Filter = "Text Files|*.txt";
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                richTextBox2.LoadFile(openFile1.FileName, RichTextBoxStreamType.PlainText);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFile1 = new SaveFileDialog();
            saveFile1.DefaultExt = "*.txt";
            saveFile1.Filter = "Text Files|*.txt";
            if (saveFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK && saveFile1.FileName.Length > 0)
            {
                richTextBox3.SaveFile(saveFile1.FileName, RichTextBoxStreamType.PlainText);
            }
        }
    }
}
