﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.IO;

namespace CSI_L1_CezarAlgorithm
{
    public partial class frmCezarEncrypt : Form
    {
        public frmCezarEncrypt()
        {
            InitializeComponent();
        }

        // ***********
        // References
        // ***********
        /*
         https://social.msdn.microsoft.com/Forums/vstudio/en-US/c88581fc-645b-462b-b0f8-e20512be88ed/add-characters-to-string?forum=csharpgeneral
         https://msdn.microsoft.com/en-us/library/ewdd6aed(v=vs.110).aspx
         http://stackoverflow.com/questions/9012055/indentation-shortcuts-in-visual-studio
         http://stackoverflow.com/questions/1553235/to-show-a-new-form-on-click-of-a-button-in-c-sharp
               
          
         */



        private void frmCezarEncrypt_Load(object sender, EventArgs e)
        {
            txtIncrement.Text = "4";
            txtText.Text = "Cezar's Algorithm !";

        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            int n = 0, i;
            String s;

            try
            {
                n = Convert.ToInt32(txtIncrement.Text);
            }
            catch (Exception ex) { MessageBox.Show("Incremental number: " + ex); }
            if (n < 0)
            {
                n = 0;
                txtIncrement.Text = "0";
            }
            if (n > (int)'Z' - (int)'A')
            { n = (int)'Z' - (int)'A'; txtIncrement.Text = "" + ((int)'Z' - (int)'A'); }



            s = txtText.Text;
            s = s.ToUpper();

            int index = 0, count = 0; ;

            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]

            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    count++;
            Char[] sE = new Char[count];
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE[index++] = s[i];



            String ss = new string(sE);
            txtTextTrimmed.Text = ss;

            Char[] sEE = new Char[ss.Length];


            for (i = 0; i < ss.Length; i++)
            {
                if ((int)ss[i] + n > (int)'Z')
                    sEE[i] = (char)((int)'A' + ((int)ss[i] + n - 1 - (int)'Z'));
                else
                    sEE[i] = (char)((int)ss[i] + n);

            }


            String sEncrypted = new string(sEE);
            txtTextEncrypted.Text = sEncrypted;

            txtAlphabet.Text = "";
            txtAlphabetEncrypted.Text = "";

            for (i = (int)'A'; i <= (int)'Z'; i++)
            {
                txtAlphabet.AppendText("" + (char)i + "  ");

                if (i + n > (int)'Z')
                    txtAlphabetEncrypted.AppendText("" + (char)((int)'A' + (i + n - 1 - (int)'Z')) + "  ");
                else
                    txtAlphabetEncrypted.AppendText("" + (char)(i + n) + "  ");
            }
        }



        #region MODULAR_CAESAR_ALGORITHM


        // 1.Optimise


        private int ConvertSanitizeKey(string s)
        {
            int key = 0;

            try
            {
                key = Convert.ToInt32(s);
            }
            catch (Exception ex) { MessageBox.Show("Key: " + ex); }
            if (key < 0)
                key = 0;
            if (key > (int)'Z' - (int)'A')
                key = (int)'Z' - (int)'A';

            return key;
        }
        private string CaesarEncrypt(string s, int key)
        {
            int n = key, i, index = 0, count = 0;


            // ----- Prepare text for Encryption
            // ----- [START]

            s = s.ToUpper();  // Turn letters to UPPER
            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]

            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    count++;
            Char[] sE = new Char[count];
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE[index++] = s[i];
            // ----- [END]


            String ss = new string(sE);
            //txtTextTrimmed.Text = ss;

            Char[] sEE = new Char[ss.Length];

            for (i = 0; i < ss.Length; i++)
            {
                if ((int)ss[i] + n > (int)'Z')
                    sEE[i] = (char)((int)'A' + ((int)ss[i] + n - 1 - (int)'Z'));
                else
                    sEE[i] = (char)((int)ss[i] + n);

            }
            String sEncrypted = new string(sEE);
            return sEncrypted;
        }

        #endregion

        private void btnLoadText_Click(object sender, EventArgs e)
        {
            try
            {
                String line;
                StreamReader fileIn = new StreamReader(txtLoad.Text);
               
                while ((line = fileIn.ReadLine())!=null)
                    txtText.Text += line;
                fileIn.Close();
            }
            catch (Exception ex) { MessageBox.Show("Load text: " + ex); }

        }

        private void btnSaveEncryptedText_Click(object sender, EventArgs e)
        {
            try
            {
                String line;
                StreamReader fileIn = new StreamReader(txtLoad.Text);
                StreamWriter fileOut = new StreamWriter(txtSave.Text);
                while ((line = fileIn.ReadLine()) != null)
                    fileOut.WriteLine("" + CaesarEncrypt(line, ConvertSanitizeKey(txtIncrement.Text)));
                fileIn.Close(); fileOut.Close();
            }

            catch (Exception ex) { MessageBox.Show("Save text: " + ex); }
            txtSave.BackColor = Color.OrangeRed;
        }

    }
}
