﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CriptingTool
{
    public partial class ADFGVX : Form
    {
        public ADFGVX()
        {
            InitializeComponent();
        }

        //functie pentru a selecta doar literele dintr-un text
        private string eliminaCaractereSpeciale(string sir)
        {
            string sir_nou = "";
            for (int i = 0; i < sir.Length; i++)
                if (char.IsLetter(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //functie pentru eliminare literelor duplicat din cheie
        private string eliminaDubluri(string sir)
        {
            string sir_nou = "";
            sir_nou += sir[0];
            for (int i = 1; i < sir.Length; i++)
                if (!sir_nou.Contains(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //functia construieste matricea 1 dupa cheia 1
        private char[,] construiesteMatriceCheie1(string cheie)
        {
            char[,] matrice = new char[7, 7];
            int k = 0;
            char litera = 'A';
            char cifra = '0';
            string matrice_cheie_sir = cheie;
            string sir = "ADFGVX";
            matrice[0, 0] = '*';

            //punem pe prima linie din matrice sirul "ADFGVX"
            for (int i = 1; i < 7; i++)
                matrice[0, i] = sir[i-1];

            //punem pe prima coloana din matrice sirul "ADFGVX"
            for (int i = 1; i < 7; i++)
                matrice[i, 0] = sir[i-1];
            //completam restul matricei
            for (int i = 1; i < 7; i++)
                for (int j = 1; j < 7; j++)
                {
                    //punem in matrice literele din cheie
                    if (k < cheie.Length)
                    {
                        matrice[i, j] = cheie[k];
                        k++;
                    }
                    else
                    {
                        //punem cifrele in matrice
                        if (litera == 'Z')
                        {
                            matrice[i, j] = cifra;
                            cifra = (char)(cifra + 1);
                        }
                        //completam cu restul literelor care nu sunt in cheie
                        else
                        {
                            while (matrice_cheie_sir.Contains(litera))
                                litera = (char)(litera + 1);
                            matrice_cheie_sir += litera;
                            matrice[i, j] = litera;
                        }
                    }
                }
            return matrice;
        }

        private string criptare_ADFGVX_faza1(string text, char[,] matrice_criptare)
        {
            string text_nou = "";
            for (int i = 0; i < text.Length; i++)
                for (int j = 1; j < 7; j++)
                    for (int k = 1; k < 7; k++)
                        if(text[i] == matrice_criptare[j,k])
                        {
                            text_nou += matrice_criptare[j, 0];
                            text_nou += matrice_criptare[0, k];
                        }
            return text_nou;
        }

        //functia construieste matricea 2 dupa cheia 2
        private char[,] construiesteMatriceCheie2_criptare(string text, string cheie, char[,] matrice)
        {
            int k = 0;
            string sir = "ADFGVX";
            Random random_char = new Random();

            for (int j = 0; j < matrice.GetLength(1); j++)
                for (int i = 0; i < matrice.GetLength(0); i++)
                {
                    if (j == 0)
                        matrice[i, j] = cheie[i];
                    else
                        if(k != text.Length)
                            matrice[i, j] = text[k++];
                        else
                            matrice[i, j] = sir[random_char.Next(sir.Length)];
                }

            return matrice;
        }

        private String criptare_ADFGVX_faza2(char[,] matrice, String cheie)
        {
            String text = "";
            char litera_minima;
            int index;

            for (int i = 0; i < cheie.Length; i++)
            {
                litera_minima = cheie[0];
                index = 0;
                for (int j = 0; j < cheie.Length; j++)
                    if (litera_minima > cheie[j])
                    {
                        litera_minima = cheie[j];
                        index = j;
                    }
                cheie = cheie.Replace(litera_minima, (char)('Z'+1));
                for (int k = 1; k < matrice.GetLength(1); k++)
                    text += matrice[index, k];
            }
            return text;
        }

        private char[,] construiesteMatriceCheie2_decriptare(string text, string cheie, char[,] matrice)
        {
            int p = 0;
            char litera_minima;
            for (int i = 0; i < matrice.GetLength(0); i++)
                for (int j = 0; j < matrice.GetLength(1); j++)
                    if (j == 0)
                    {
                        litera_minima = cheie[0];
                        for (int k = 0; k < cheie.Length; k++)
                            if (litera_minima > cheie[k])
                                litera_minima = cheie[k];
                        cheie = cheie.Replace(litera_minima, (char)('Z' + 1));
                        matrice[i, j] = litera_minima;
                    }
                    else
                        matrice[i, j] = text[p++];
            return matrice;
        }

        private String decriptare_ADFGVX_faza1(char[,] matrice, String cheie)
        {
            String matrice_sir = "", text = "";
            int p = 0;

            for (int i = 0; i < cheie.Length; i++)
                for (int j = 0; j < cheie.Length; j++)
                    if (matrice[j, 0] == cheie[i])
                        for (int k = 1; k < matrice.GetLength(1); k++)
                            matrice_sir += matrice[j, k];

            for (int i = 0; i < matrice.GetLength(0); i++)
                for (int j = 1; j < matrice.GetLength(1); j++)
                    matrice[i, j] = matrice_sir[p++];

            for (int j = 1; j < matrice.GetLength(1); j++)
                for (int i = 0; i < matrice.GetLength(0); i++)
                    text += matrice[i, j];
            return text;
        }

        private String decriptare_ADFGVX_faza2(String text, char[,] matrice)
        {
            String text_nou = "";
            int index_linie = 0, index_coloana = 0;
            for (int i = 0; i < text.Length-1; i = i + 2)
            {
                for (int j = 1; j < matrice.GetLength(0); j++)
                    if (text[i] == matrice[j, 0])
                        index_linie = j;
                for (int j = 1; j < matrice.GetLength(1); j++)
                    if (text[i+1] == matrice[0, j])
                        index_coloana = j;
                text_nou += matrice[index_linie, index_coloana];
            }
            return text_nou;
        }

        private void cripteazaABtn_Click(object sender, EventArgs e)
        {
            string cheie1 = cheie1TxtB.Text;
            string cheie2 = cheie2TxtB.Text;
            string text = initialATxtB.Text;
            char[,] matrice_cheie1 = new char[7, 7];
            int numar_coloane;
            char[,] matrice_cheie2;

            //verificam daca a fost introdus text pentru criptat
            if (initialATxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
                //verificam daca au fost introduse cheile de criptare
                if (cheie1TxtB.Text == "" || cheie2TxtB.Text == "")
                    MessageBox.Show("Introdu cheile de criptare!");
                //criptam textul
                else
                {
                    //selectam doar literele din cheia1 si le transformam in litere capitale
                    cheie1 = eliminaCaractereSpeciale(cheie1);
                    cheie1 = cheie1.ToUpper();
                    //eliminam literele care se repeta din cheia 1 de criptare
                    cheie1 = eliminaDubluri(cheie1);
                    //construim matricea 1 de criptare
                    matrice_cheie1 = construiesteMatriceCheie1(cheie1);
                    //selectam doar literele din text si le transformam in litere capitale
                    text = eliminaCaractereSpeciale(text);
                    text = text.ToUpper();
                    //criptam textul folosind cheia 1
                    text = criptare_ADFGVX_faza1(text, matrice_cheie1);

                    //selectam doar literele din cheia2 si le transformam in litere capitale
                    cheie2 = eliminaCaractereSpeciale(cheie2);
                    cheie2 = cheie2.ToUpper();
                    //eliminam literele care se repeta din cheia2 de criptare
                    cheie2 = eliminaDubluri(cheie2);
                    //calculam numarul de coloane pentru matricea 2
                    numar_coloane = (text.Length % cheie2.Length == 0 ? text.Length / cheie2.Length + 1 : text.Length / cheie2.Length + 2);
                    //alocam memorie pentru matricea 2
                    matrice_cheie2 = new char[cheie2.Length, numar_coloane];
                    //construim matricea 2 de criptare
                    matrice_cheie2 = construiesteMatriceCheie2_criptare(text, cheie2, matrice_cheie2);
                    //criptam textul folosind cheia 2
                    text = criptare_ADFGVX_faza2(matrice_cheie2, cheie2);
                    //afisam textul criptat final
                    finalATxtB.Text = text;
                }
        }

        private void decripteazaABtn_Click(object sender, EventArgs e)
        {
            string cheie1 = cheie1TxtB.Text;
            string cheie2 = cheie2TxtB.Text;
            string text = initialATxtB.Text;
            char[,] matrice_cheie1 = new char[7, 7];
            char[,] matrice_cheie2 = new char[cheie2.Length, text.Length/cheie2.Length + 1];

            //verificam daca a fost introdus text pentru decriptat
            if (initialATxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
                //verificam daca au fost introdusa cheile pentru decriptare
                if (cheie1TxtB.Text == "" || cheie2TxtB.Text == "")
                    MessageBox.Show("Introdu cheile pentru decriptare!");
                //decriptam textul
                else
                {
                    //selectam doar literele din text si le transformam in litere capitale
                    text = eliminaCaractereSpeciale(text);
                    text = text.ToUpper();
                    //selectam doar literele din cheia2 si le transformam in litere capitale
                    cheie2 = eliminaCaractereSpeciale(cheie2);
                    cheie2 = cheie2.ToUpper();
                    //eliminam literele care se repeta din cheia2 de criptare
                    cheie2 = eliminaDubluri(cheie2);
                    //construim prima matrice folosind cheie de decriptare 2
                    matrice_cheie2 = construiesteMatriceCheie2_decriptare(text, cheie2, matrice_cheie2);
                    //criptam textul folosind cheia 2
                    text = decriptare_ADFGVX_faza1(matrice_cheie2, cheie2);
                    
                    //selectam doar literele din cheia1 si le transformam in litere capitale
                    cheie1 = eliminaCaractereSpeciale(cheie1);
                    cheie1 = cheie1.ToUpper();
                    //eliminam literele care se repeta din cheia 1 de criptare
                    cheie1 = eliminaDubluri(cheie1);
                    //construim a doua matrice folosind cheia de decriptare 1
                    matrice_cheie1 = construiesteMatriceCheie1(cheie1);
                    //criptam textul folosind cheia 1
                    text = decriptare_ADFGVX_faza2(text, matrice_cheie1);

                    //afisam textul criptat final
                    finalATxtB.Text = text;
                }
        }
    }
}
