﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CriptingTool
{
    public partial class Enigma : Form
    {
        String[] alfabet = new String[] { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };
        String[] rotor1 = new String[] { "E", "K", "M", "F", "L", "G", "D", "Q", "V", "Z", "N", "T", "O", "W", "Y", "H", "X", "U", "S", "P", "A", "I", "B", "R", "C", "J" };
        String[] rotor2 = new String[] { "A", "J", "D", "K", "S", "I", "R", "U", "X", "B", "L", "H", "W", "T", "M", "C", "Q", "G", "Z", "N", "P", "Y", "F", "V", "O", "E" };
        String[] rotor3 = new String[] { "B", "D", "F", "H", "J", "L", "C", "P", "R", "T", "X", "V", "Z", "N", "Y", "E", "I", "W", "G", "A", "K", "M", "U", "S", "Q", "O" };
        String[] reflectorB = new String[] { "AY", "BR", "CU", "DH", "EQ", "FS", "GL", "IP", "JX", "KN", "MO", "TZ", "VW" };
        String[] reflectorC = new String[] { "AF", "BV", "CP", "DJ", "EI", "GO", "HY", "KR", "LZ", "MX", "NW", "TQ", "SU" };
        
        public Enigma()
        {
            InitializeComponent();
        }

        //functie pentru a selecta doar literele dintr-un text
        private string eliminaCaractereSpeciale(string sir)
        {
            string sir_nou = "";
            for (int i = 0; i < sir.Length; i++)
                if (char.IsLetter(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        private String criptareEnigma(String text, String[] reflector)
        {
            String text_nou = "";
            for (int i = 0; i < text.Length; i++)
                text_nou += criptareLitera(text.ElementAt(i), reflector);

            return text_nou;
        }

        private char criptareLitera(char litera, String[] reflector)
        {
            
            for (int i = 0; i < alfabet.Length; i++)
                if (alfabet[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = rotor3[i].ElementAt(0);
                    break;
                }
            
            for (int i = 0; i < alfabet.Length; i++)
                if (alfabet[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = rotor2[i].ElementAt(0);
                    break;
                }
            
            for (int i = 0; i < alfabet.Length; i++)
                if (alfabet[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = rotor1[i].ElementAt(0);
                    break;
                }
            
            for (int i = 0; i < reflector.Length; i++)
            {
                if (reflector[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = reflector[i].ElementAt(1);
                    break;
                }
                if (reflector[i].ElementAt(1).CompareTo(litera) == 0)
                {
                    litera = reflector[i].ElementAt(0);
                    break;
                }
            }
            
            for (int i = 0; i < rotor1.Length; i++)
                if (rotor1[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = alfabet[i].ElementAt(0);
                    break;
                }
            
            for (int i = 0; i < rotor2.Length; i++)
                if (rotor2[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = alfabet[i].ElementAt(0);
                    break;
                }
            
            for (int i = 0; i < rotor3.Length; i++)
                if (rotor3[i].ElementAt(0).CompareTo(litera) == 0)
                {
                    litera = alfabet[i].ElementAt(0);
                    break;
                }

            return litera;
        }

        private void cripteazaBtn_Click(object sender, EventArgs e)
        {
            string text = initialETxtB.Text;
            String[] reflector;

            if (reflectorBRBtn.Checked == true)
                reflector = reflectorB;
            else
                reflector = reflectorC;

            //verificam daca a fost introdus text pentru criptat/decriptat
            if (initialETxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
            {
                //selectam doar caracterele din textul
                text = eliminaCaractereSpeciale(text);
                //transforman literele din textul in litere capitale
                text = text.ToUpper();
                //criptam textul
                text = criptareEnigma(text, reflector);
                //afisam textul criptat/decriptat
                finalETxtB.Text = text;
            }
        }
    }
}
