﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CriptingTool
{
    public partial class Homophonic : Form
    {
        public Homophonic()
        {
            InitializeComponent();
        }

        //functie pentru a selecta doar literele dintr-un text
        private string eliminaCaractereSpeciale(string sir)
        {
            string sir_nou = "";
            for (int i = 0; i < sir.Length; i++)
                if (char.IsLetter(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //functie elimina din text tot ce nu este numar
        private string eliminaCaractereNonNumerice(string sir)
        {
            string sir_nou = "";
            for (int i = 0; i < sir.Length; i++)
                if (char.IsDigit(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //eliminam dublurile din cheie si verificam daca lungimea ramane tot 4
        private string eliminaDubluri(string sir)
        {
            string sir_nou = "";
            sir_nou += sir[0];
            for (int i = 1; i < sir.Length; i++)
                if (!sir_nou.Contains(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //functia construieste matricea cheie
        private String[,] construiesteMatriceCheie(string cheie)
        {
            String[,] matrice = new String[5, 25];
            char litera = 'A';
            int coloana_litera1 = 0, coloana_litera2 = 0, coloana_litera3 = 0, coloana_litera4 = 0;
            int numar = 0;
            //completam prima linie din matrice cu literele din alfabet cu exceptia 'J'
            for (int i = 0; i < matrice.GetLength(1); i++)
            {
                if (litera == 'J') litera++;
                matrice[0, i] += (char)litera++;
            }

            //memoram pozitiile pe coloana a literelor din cheie
            for (int i = 0; i < matrice.GetLength(1); i++)
            {
                if (cheie.ElementAt(0).CompareTo(matrice[0, i].ElementAt(0)) == 0)
                    coloana_litera1 = i;
                if (cheie.ElementAt(1).CompareTo(matrice[0, i].ElementAt(0)) == 0)
                    coloana_litera2 = i;
                if (cheie.ElementAt(2).CompareTo(matrice[0, i].ElementAt(0)) == 0)
                    coloana_litera3 = i;
                if (cheie.ElementAt(3).CompareTo(matrice[0, i].ElementAt(0)) == 0)
                    coloana_litera4 = i;
            }

            //completam prima parte din linia1
            numar = matrice.GetLength(1) - coloana_litera1 + 1;
            for (int i = 0; i < coloana_litera1; i++)
                if (numar < 10)
                    matrice[1, i] += "0" + numar++;
                else
                    matrice[1, i] += numar++;

            //completam a doua parte din linia1
            numar = 1;
            for (int i = coloana_litera1; i < matrice.GetLength(1); i++)
                if (numar < 10)
                    matrice[1, i] += "0" + numar++;
                else
                    matrice[1, i] += numar++;

            //completam prima parte din linia2
            numar = matrice.GetLength(1) - coloana_litera2 + 1 + 25;
            for (int i = 0; i < coloana_litera2; i++)
                matrice[2, i] += numar++;

            //completam a doua parte din linia2
            numar = 26;
            for (int i = coloana_litera2; i < matrice.GetLength(1); i++) 
                matrice[2, i] += numar++;

            //completam prima parte din linia3
            numar = matrice.GetLength(1) - coloana_litera3 + 1 + 50;
            for (int i = 0; i < coloana_litera3; i++)
                matrice[3, i] += numar++;

            //completam a doua parte din linia3
            numar = 51;
            for (int i = coloana_litera3; i < matrice.GetLength(1); i++)
                matrice[3, i] += numar++;

            //completam prima parte din linia4
            numar = matrice.GetLength(1) - coloana_litera4 + 1 + 75;
            for (int i = 0; i < coloana_litera4; i++)
            {
                if (numar == 100) matrice[4, i] += "00";
                else matrice[4, i] += numar++;
            }

            //completam a doua parte din linia4
            numar = 76;
            for (int i = coloana_litera4; i < matrice.GetLength(1); i++)
                matrice[4, i] += numar++;

            return matrice;
        }

        private String criptareHomophonic(String text, String[,] matrice)
        {
            String text_nou = "";
            Random random_linie_matrice = new Random();

            for (int i = 0; i < text.Length; i++)
                for (int j = 0; j < matrice.GetLength(1); j++)
                    if (text.ElementAt(i).CompareTo(matrice[0, j].ElementAt(0)) == 0)
                        text_nou += matrice[random_linie_matrice.Next(1, 4), j] + " "; 
            return text_nou;
        }

        private String decriptareHomophonic(String text, String[,] matrice)
        {
            String text_nou = "";
            String litera = "";
            for (int k = 0; k < text.Length-1; k = k + 2)
            {
                litera = "";
                litera += text.ElementAt(k);
                litera += text.ElementAt(k + 1);
                for (int i = 1; i < matrice.GetLength(0); i++)
                    for (int j = 0; j < matrice.GetLength(1); j++)
                        if (litera.CompareTo(matrice[i, j]) == 0)
                            text_nou += matrice[0, j];
            }
            return text_nou;
        }
        private void cripteazaHBtn_Click(object sender, EventArgs e)
        {
            string cheie = cheieTxtB.Text;
            string text = initialHTxtB.Text;
            String[,] matrice_cheie = new String[5, 25];
            if(cheieTxtB.Text != "") cheie = eliminaDubluri(cheie);

            //verificam daca a fost introdus text pentru criptat
            if (initialHTxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
                //verificam a fost introdusa cheia de criptare
                if (cheieTxtB.Text == "" || cheieTxtB.Text.Length != 4)
                    MessageBox.Show("Introdu o cheie de criptare formata din 4 litere distincte!");
                //criptam textul
                else
                {
                    //selectam doar literele din cheie
                    cheie = eliminaCaractereSpeciale(cheie);
                    //transformam literele din cheie in litere capitale
                    cheie = cheie.ToUpper();

                    //construim matricea cheie
                    matrice_cheie = construiesteMatriceCheie(cheie);

                    //selectam doar caracterele din textul de criptat
                    text = eliminaCaractereSpeciale(text);
                    //transforman literele din textul de criptat in litere capitale
                    text = text.ToUpper();
                    //inlocuim literele 'J' cu 'I' in textul de criptat
                    text = text.Replace("J", "I");
                    //criptam textul
                    text = criptareHomophonic(text, matrice_cheie);

                    //afisam textul criptat
                    finalHTxtB.Text = text;
                }
        }

        private void decripteazaHBtn_Click(object sender, EventArgs e)
        {
            string cheie = cheieTxtB.Text;
            string text = initialHTxtB.Text;
            String[,] matrice_cheie = new String[5, 25];
            if (cheieTxtB.Text != "") cheie = eliminaDubluri(cheie);

            //verificam daca a fost introdus text pentru decriptat
            if (initialHTxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
                //verificam a fost introdusa cheia pentru decriptare
                if (cheieTxtB.Text == "" || cheieTxtB.Text.Length != 4)
                    MessageBox.Show("Introdu o cheie pentru decriptare formata din 4 litere distincte!");
                //criptam textul
                else
                {
                    //selectam doar literele din cheie
                    cheie = eliminaCaractereSpeciale(cheie);
                    //transformam literele din cheie in litere capitale
                    cheie = cheie.ToUpper();

                    //construim matricea cheie
                    matrice_cheie = construiesteMatriceCheie(cheie);
                    //eliminam caracterele care nu sunt numere
                    text = eliminaCaractereNonNumerice(text);
                    //decriptam textul
                    text = decriptareHomophonic(text, matrice_cheie);

                    //afisam textul criptat
                    finalHTxtB.Text = text;
                }
        }
    }
}
