﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CriptingTool
{
    public partial class Playfair : Form
    {
        public Playfair()
        {
            InitializeComponent();
        }

        //functie pentru eliminare literelor duplicat din cheie
        private string eliminaDubluri(string sir)
        {
            string sir_nou = "";
            sir_nou += sir[0];
            for (int i = 1; i < sir.Length; i++)
                if (!sir_nou.Contains(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }

        //functie pentru a selecta doar literele dintr-un text
        private string eliminaCaractereSpeciale(string sir)
        {
            string sir_nou = "";
            for (int i = 0; i < sir.Length; i++)
                if (char.IsLetter(sir[i]))
                    sir_nou += sir[i];
            return sir_nou;
        }
        //functia construieste matricea cheie
        private char[,] construiesteMatriceCheie(string cheie)
        {
            char[,] matrice = new char[5, 5];
            int k = 0;
            char litera = 'A';
            string matrice_cheie_sir = cheie;

            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 5; j++)
                {
                    //punem in matrice literele din cheie
                    if (k < cheie.Length)
                    {
                        matrice[i, j] = cheie[k];
                        k++;
                    }
                    //completam cu restul literelor din alfabet in afara de litera 'J'
                    else
                    {
                        while (matrice_cheie_sir.Contains(litera) || litera == 'J')
                            litera = (char)(litera + 1);
                        matrice_cheie_sir += litera;
                        matrice[i, j] = litera;
                    }
                }
            return matrice;
        }

        //functia imparte un text format doar din litere in grupuri de doua litere separate de spatiu
        private string grupuri2Litere(string sir)
        {
            string sir_nou = "";
            sir_nou += sir[0];
            for (int i = 1; i < sir.Length; i++)
                if (i % 2 == 0)
                {
                    sir_nou += ' ';
                    sir_nou += sir[i];
                }
                else
                    sir_nou += sir[i];
            return sir_nou;
        }

        //tratam cazul in care intr-un cuplu avem aceeasi litera de doua ori
        private string trateazaCupluriDublura(string sir)
        {
            string sir_nou = sir;

            for (int i = 0; i < sir_nou.Length - 1; i++)
            {
                //cazul in care in grupul anterior am avut doua litere identice si s-a inserat 'X'
                if (i > 3 && sir_nou[i] == sir_nou[i - 3] && sir_nou[i - 2] == 'X' && sir_nou[i] == sir_nou[i + 1])
                {
                    sir_nou = sir_nou.Insert(i + 1, "Z");
                    sir_nou = sir_nou.Replace(" ", "");
                    sir_nou = grupuri2Litere(sir_nou);
                }
                //cazul in care intalnim un grup de litere identice
                if (sir_nou[i] == sir_nou[i + 1])
                {
                    sir_nou = sir_nou.Insert(i + 1, "X");
                    sir_nou = sir_nou.Replace(" ", "");
                    sir_nou = grupuri2Litere(sir_nou);
                }
            }
            return sir_nou;
        }
        //functia de criptare
        private string criptarePlayfair(string text, char[,] cheie)
        {
            char litera1, litera2;
            string text_codat = " ";
            int litera1_i = 0, litera1_j = 0, litera2_i = 0, litera2_j = 0;
            for (int k = 0; k < text.Length - 1; k++)
            {
                //selectam fiecare grup de doua litere
                if (char.IsLetter(text[k]) && char.IsLetter(text[k + 1]))
                {
                    litera1 = text[k];
                    litera2 = text[k + 1];
                    //cautam cele doua litere in matricea cheie
                    for (int i = 0; i < 5; i++)
                        for (int j = 0; j < 5; j++)
                        {
                            //salvam pozitiile in matricea cheie a celor doua litere
                            if (litera1 == cheie[i, j])
                            {
                                litera1_i = i;
                                litera1_j = j;
                            }
                            if (litera2 == cheie[i, j])
                            {
                                litera2_i = i;
                                litera2_j = j;
                            }
                        }
                    //verificam daca literele se afla pe linii si coloane diferite
                    //afisam literele care au aceleasi linii cu litera1, respectiv litera2 si inversam coloanele 
                    if (litera1_i != litera2_i && litera1_j != litera2_j)
                    {
                        text_codat += cheie[litera1_i, litera2_j];
                        text_codat += cheie[litera2_i, litera1_j];
                    }
                    //verificam daca literele se afla pe aceeasi linie dar pe coloane diferite
                    //afisam literele de pe aceeasi linie si de pe aceeasi coloana incrementata cu o pozitie
                    if(litera1_i == litera2_i && litera1_j != litera2_j)
                    {
                        //verificam daca litera1 sau litera2 se afla pe ultima coloana a matricei
                        if (litera1_j == 4)
                            text_codat += cheie[litera1_i, 0];
                        else
                            text_codat += cheie[litera1_i, litera1_j + 1];

                        if (litera2_j == 4) 
                            text_codat += cheie[litera2_i, 0];
                        else
                            text_codat += cheie[litera2_i, litera2_j + 1];
                    }
                    //verificam daca literele se afla pe aceeasi coloana dar pe linii diferite
                    //afisam literele de pe aceeasi coloana si de pe aceeasi linia incrementata cu o pozitie
                    if (litera1_i != litera2_i && litera1_j == litera2_j)
                    {
                        //verificam daca litera 1 sau litera2 se afla pe ultima linie a matricei
                        if (litera1_i == 4)
                            text_codat += cheie[0, litera1_j];
                        else
                            text_codat += cheie[litera1_i + 1, litera1_j];

                        if (litera2_i == 4)
                            text_codat += cheie[0, litera2_j];
                        else
                            text_codat += cheie[litera2_i + 1, litera2_j];
                    }
                }
            }
            return text_codat;
        }

        //tratam cazurile in care avem "*X *+" sau "*X *Z", unde * si + sunt litere
        private string trateazaCazuriXZ(string sir)
        {
            string sir_nou = sir;
            //eliminam 'Z'
            for (int i = 0; i < sir_nou.Length - 1; i++) 
                if (i > 3 && sir_nou[i] == sir_nou[i - 3] && sir_nou[i - 2] == 'X' && sir_nou[i + 1] =='Z')
                {
                    sir_nou = sir_nou.Remove(i + 1, 1);
                    sir_nou = sir_nou.Replace(" ", "");
                    sir_nou = grupuri2Litere(sir_nou);
                }
            //eliminam 'X'
            for (int i = 0; i < sir_nou.Length - 3; i++)
                if (sir_nou[i] == sir_nou[i + 3] && sir_nou[i + 1] == 'X')
                {
                    sir_nou = sir_nou.Remove(i + 1, 1);
                    sir_nou = sir_nou.Replace(" ", "");
                    sir_nou = grupuri2Litere(sir_nou);
                }
            sir_nou = sir_nou.Replace(" ", "");
            return sir_nou;
        }

        //functia de decriptare
        private string decriptarePlayfair(string text, char[,] cheie)
        {
            char litera1, litera2;
            string text_decodat = "";
            int litera1_i = 0, litera1_j = 0, litera2_i = 0, litera2_j = 0;
            for (int k = 0; k < text.Length - 1; k++)
            {
                //selectam fiecare grup de doua litere
                if (char.IsLetter(text[k]) && char.IsLetter(text[k + 1]))
                {
                    litera1 = text[k];
                    litera2 = text[k + 1];
                    //cautam cele doua litere in matricea cheie
                    for (int i = 0; i < 5; i++)
                        for (int j = 0; j < 5; j++)
                        {
                            //salvam pozitiile in matricea cheie a celor doua litere
                            if (litera1 == cheie[i, j])
                            {
                                litera1_i = i;
                                litera1_j = j;
                            }
                            if (litera2 == cheie[i, j])
                            {
                                litera2_i = i;
                                litera2_j = j;
                            }
                        }
                    //verificam daca literele se afla pe linii si coloane diferite
                    //afisam literele care au aceleasi linii cu litera1, respectiv litera2 si inversam coloanele 
                    if (litera1_i != litera2_i && litera1_j != litera2_j)
                    {
                        text_decodat += cheie[litera1_i, litera2_j];
                        text_decodat += cheie[litera2_i, litera1_j];
                    }
                    //verificam daca literele se afla pe aceeasi linie dar pe coloane diferite
                    //afisam literele de pe aceeasi linie si de pe aceeasi coloana decrementata cu o pozitie
                    if (litera1_i == litera2_i && litera1_j != litera2_j)
                    {
                        //verificam daca litera1 sau litera2 se afla pe ultima coloana a matricei
                        if (litera1_j == 0)
                            text_decodat += cheie[litera1_i, 4];
                        else
                            text_decodat += cheie[litera1_i, litera1_j - 1];

                        if (litera2_j == 0)
                            text_decodat += cheie[litera2_i, 4];
                        else
                            text_decodat += cheie[litera2_i, litera2_j - 1];
                    }
                    //verificam daca literele se afla pe aceeasi coloana dar pe linii diferite
                    //afisam literele de pe aceeasi coloana si de pe aceeasi linia decrementata cu o pozitie
                    if (litera1_i != litera2_i && litera1_j == litera2_j)
                    {
                        //verificam daca litera 1 sau litera2 se afla pe prima linie a matricei
                        if (litera1_i == 0)
                            text_decodat += cheie[4, litera1_j];
                        else
                            text_decodat += cheie[litera1_i - 1, litera1_j];

                        if (litera2_i == 0)
                            text_decodat += cheie[4, litera2_j];
                        else
                            text_decodat += cheie[litera2_i - 1, litera2_j];
                    }
                }
            }
            return text_decodat;
        }

        private void cripteazaPBtn_Click(object sender, EventArgs e)
        {
            string cheie = cheieTxtB.Text;
            string text = initialPTxtB.Text;
            char[,] matrice_cheie = new char[5, 5];

            //verificam daca a fost introdus text pentru criptat
            if (initialPTxtB.Text == "")
                MessageBox.Show("Căsuța text este goală. Trebuie să introduci un text!");
            else
                //verificam a fost introdusa cheia de criptare
                if (cheieTxtB.Text == "")
                    MessageBox.Show("Introdu cheia de criptare!");
                //criptam textul
                else
                {
                    //selectam doar literele din cheie
                    cheie = eliminaCaractereSpeciale(cheie);
                    //transformam literele din cheie in litere capitale
                    cheie = cheie.ToUpper();
                    //inlocuim literele 'J' cu 'I' in cheie
                    cheie = cheie.Replace("J", "I");
                    //eliminam literele duplicat din cheia de criptare
                    cheie = eliminaDubluri(cheie);
                    //construim matricea cheie
                    matrice_cheie = construiesteMatriceCheie(cheie);

                    //selectam doar caracterele din textul de criptat
                    text = eliminaCaractereSpeciale(text);
                    //transforman literele din textul de criptat in litere capitale
                    text = text.ToUpper();
                    //inlocuim literele 'J' cu 'I' in textul de criptat
                    text = text.Replace("J", "I");
                    //impartim literele in grupuri de cate doua, separate de spatiu
                    text = grupuri2Litere(text);
                    //tratam cazul in care intr-un grup avem aceeasi litera de doua ori
                    text = trateazaCupluriDublura(text);
                    //in cazul in care textul are lungime impara, adaugam un carater la alegere la sfarsit ('B')
                    if (text.Length - 1 % 2 != 0)
                        text += 'B';
                    //criptam textul
                    text = criptarePlayfair(text, matrice_cheie);
                }
            //afisam textul criptat
            finalPTxtB.Text = text;
        }

        private void decripteazaPBtn_Click(object sender, EventArgs e)
        {
            string cheie = cheieTxtB.Text;
            string text = initialPTxtB.Text;
            char[,] matrice_cheie = new char[5, 5];

            //verificam validitatea textului, acesta trebuie sa fie format din litere capitale
            //in cazul in care se gaseste un caracter in afara intervalului [A-Z] sau nu exista text, se intrerupe cautarea
            for (int i = 0; i < text.Length; i++)
                if (text[i] < 'A' || text[i] > 'Z')
                {
                    MessageBox.Show("Textul introdus este invalid.Trebuie să introduci un text format doar litere capitale!");
                    initialPTxtB.Text = "";
                    break;
                }
            //verificam a fost introdusa cheia de criptare
            if (cheieTxtB.Text == "")
                MessageBox.Show("Introdu cheia de decriptare!");
            //decriptam textul
            else
            {
                //selectam doar literele din cheie
                cheie = eliminaCaractereSpeciale(cheie);
                //transformam literele din cheie in litere capitale
                cheie = cheie.ToUpper();
                //inlocuim literele 'J' cu 'I' in cheie
                cheie = cheie.Replace("J", "I");
                //eliminam literele duplicat din cheia de criptare
                cheie = eliminaDubluri(cheie);
                //construim matricea cheie
                matrice_cheie = construiesteMatriceCheie(cheie);
                
                //impartim literele in grupuri de cate doua, separate de spatiu
                text = grupuri2Litere(text);
                //decriptam textul
                text = decriptarePlayfair(text, matrice_cheie);
                //impartim literele in grupuri de cate doua, separate de spatiu
                text = grupuri2Litere(text);
                //tratam cazurile in care avem "*X *+" sau "*X *Z", unde * si + sunt litere
                text = trateazaCazuriXZ(text);
                //transformam literele din text in litere mici
                text = text.ToLower();
            }
            //afisam textul decriptat
            finalPTxtB.Text = text;
        }
    }
}
