﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace CSI_L1_CezarAlgorithm
{
    public partial class frmCezarDecrypt : Form
    {
        public frmCezarDecrypt()
        {
            InitializeComponent();
        }

       
        private void frmCezarDecrypt_Load(object sender, EventArgs e)
        {
            txtDecrement.Text = "4";
            txtText.Text = "GIDEVWEPKSVMXLQ";
                    }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            int pozZ = (int)'Z';
            int pozA = (int)'A';
            
            
            int n = 0, i;
            String s;

            try
            {
                n = Convert.ToInt32(txtDecrement.Text);
            }
            catch (Exception ex) { MessageBox.Show("Decremental number: " + ex); }
            if (n < 0  )
            {
                n = 0 ;

                txtDecrement.Text = "0";
            }
            if (n > pozZ-pozA)
            {
                n = pozZ-pozA;
                txtDecrement.Text = "" + n;
            }

            
            
            n = (pozZ-pozA)-n+1;

            s = txtText.Text;
            s = s.ToUpper();

            int index = 0, count = 0; ;

            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]

            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    count++;
            Char[] sE = new Char[count];
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE[index++] = s[i];



            String ss = new string(sE);
            txtTextTrimmed.Text = ss;

            Char[] sEE = new Char[ss.Length];


            for (i = 0; i < ss.Length; i++)
            {
                if ((int)ss[i] + n > (int)'Z')
                    sEE[i] = (char)((int)'A' + ((int)ss[i] + n - 1 - (int)'Z'));
                else
                    sEE[i] = (char)((int)ss[i] + n);

            }


            String sEncrypted = new string(sEE);
            txtTextDecrypted.Text = sEncrypted;

            txtAlphabet.Text = "";
            txtAlphabetEncrypted.Text = "";

            for (i = (int)'A'; i <= (int)'Z'; i++)
            {
                txtAlphabet.AppendText("" + (char)i + "  ");

                if (i + n > (int)'Z')
                    txtAlphabetEncrypted.AppendText("" + (char)((int)'A' + (i + n - 1 - (int)'Z')) + "  ");
                else
                    txtAlphabetEncrypted.AppendText("" + (char)(i + n) + "  ");
            }
        }





        #region MODULAR_CAESAR_ALGORITHM_DECCRYPTION
        


        private int ConvertSanitizeKey(string s)
        {
            int key = 0;

            try
            {
                key = Convert.ToInt32(s);
            }
            catch (Exception ex) { MessageBox.Show("Key: " + ex); }
            if (key < 0)
                key = 0;
            if (key > (int)'Z' - (int)'A')
                key = (int)'Z' - (int)'A';

            return key;
        }
        private string CaesarDecrypt(string s, int key)
        {
            int n , i, index = 0, count = 0;

            n = ((int)'Z' - (int)'A') - key + 1;

            
            // ----- Prepare text for Encryption
            // ----- [START]

            s = s.ToUpper();  // Turn letters to UPPER
            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]

            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    count++;
            Char[] sE = new Char[count];
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE[index++] = s[i];
            // ----- [END]


            String ss = new string(sE);
            //txtTextTrimmed.Text = ss;

            Char[] sEE = new Char[ss.Length];

            for (i = 0; i < ss.Length; i++)
            {
                if ((int)ss[i] + n > (int)'Z')
                    sEE[i] = (char)((int)'A' + ((int)ss[i] + n - 1 - (int)'Z'));
                else
                    sEE[i] = (char)((int)ss[i] + n);

            }
            
            String sEncrypted = new string(sEE);
            return sEncrypted;
        }

        #endregion




        private void btnLoadText_Click(object sender, EventArgs e)
        {
            try
            {
                String line;
                StreamReader fileIn = new StreamReader(txtLoad.Text);

                while ((line = fileIn.ReadLine()) != null)
                    txtText.Text += line;
                fileIn.Close();
            }
            catch (Exception ex) { MessageBox.Show("Load text: " + ex); }
        }

        private void btnSaveDecryptedText_Click(object sender, EventArgs e)
        {
            try
            {
                String line;
                StreamReader fileIn = new StreamReader(txtLoad.Text);
                StreamWriter fileOut = new StreamWriter(txtSave.Text);
                while ((line = fileIn.ReadLine()) != null)
                    fileOut.WriteLine("" + CaesarDecrypt(line, ConvertSanitizeKey(txtDecrement.Text)));
                fileIn.Close(); fileOut.Close();
            }

            catch (Exception ex) { MessageBox.Show("Save text: " + ex); }
            txtSave.BackColor = Color.OrangeRed;
        }
    }
}
