﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace CSI_L2_PlayFairAlgorithm
{
    public partial class frmPlayFairDecrypt : Form
    {
        public frmPlayFairDecrypt()
        {
            InitializeComponent();
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            int i = 0;
            string s = txtText.Text;
            string key = PlayFair.PlayFairConvertSanitizeKey(txtKey.Text);
            string sE = "";
            // Matrix 5 x 5
            txtMatrix.Text = "";
                        for (i = 0; i < key.Length; i++)
            {
                if (i % 5 == 0)
                    txtMatrix.AppendText(Environment.NewLine);
                txtMatrix.AppendText(key[i] + "   ");
            }
            // Grouped characters

            for (i = 0; i < s.Length - 1; i += 2)
                txtTextTrimmed.Text += s[i] + "" + s[i + 1] + "  ";
            sE = PlayFair.PlayFairDecrypt(s, key);
            for (i = 0; i < sE.Length - 1; i += 2)
                txtTextEncryptedGrouped.Text += sE[i] + "" + sE[i + 1] + "  ";
            txtTextEncrypted.Text = sE;
        }

        private void btnLoadText_Click(object sender, EventArgs e)
        {
            txtText.Text = "";
            try
            {
                openFileDialog.InitialDirectory = Application.StartupPath;
                if (openFileDialog.ShowDialog() != null)
                {
                    String line;
                    StreamReader fileIn = new StreamReader(openFileDialog.FileName);

                    while ((line = fileIn.ReadLine()) != null)
                        txtText.Text += line;
                    fileIn.Close();
                }
            }
            catch (Exception ex) { MessageBox.Show("Load text: " + ex); }
        }

        private void btnDecryptFile_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + PlayFair.PlayFairDecrypt(line, PlayFair.PlayFairConvertSanitizeKey(txtKey.Text)));
                        
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }

        private void frmPlayFairDecrypt_Load(object sender, EventArgs e)
        {
             txtKey.Text = "First amendament!";
             txtText.Text = "OWEHEGRYTYNQBVOAEMGDMQVBXINRXGKISMBEDNTFBLOFNQENDSLIEGOFCRQMPIXEQCFCRFSMKRISGRDXGRGEOMRNSKGEMPILFEGFSREKSMKRGNISGRNAWCLIRQGRMGCQIPIFGNXENRIQSFGNSRHKIUIFGNXGPQPAXGMBNMLVZSLMRYRNACPAMDKDPQDRRFMWDSGNCPXASEENDSILFEEGETNRIQRBSRAXMDGMFH";

             openFileDialog.FileName = "PlayFairEncryptOutput.txt";
             saveFileDialog.FileName = "PlayFairDecryptOutput.txt";
        }
    }
}
