﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L2_PlayFairAlgorithm
{

    public partial class frmPlayFairEncrypt : Form
    {
        public frmPlayFairEncrypt()
        {
            InitializeComponent();
        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            int i = 0;
            string s = PlayFair.PlayFairConvertSanitizeText(txtText.Text);
            string key = PlayFair.PlayFairConvertSanitizeKey(txtKey.Text);
            string sE = "";
            // Alphabet and Encrypted Alphabet
            txtMatrix.Text = "";


            for (i = 0; i < key.Length; i++)
            {
                if (i % 5 == 0)
                    txtMatrix.AppendText(Environment.NewLine);
                txtMatrix.AppendText(key[i] + "   ");
            }

            for (i = 0; i < s.Length - 1; i += 2)
                txtTextTrimmed.Text += s[i] + "" + s[i + 1] + "  ";
            sE = PlayFair.PlayFairEncrypt(s, key);
            for (i = 0; i < s.Length - 1; i += 2)
                txtTextEncryptedGrouped.Text += sE[i] + "" + sE[i + 1] + "  ";
            txtTextEncrypted.Text = sE;
        }

        private void btnLoadText_Click(object sender, EventArgs e)
        {
            txtText.Text = "";
            try
            {
                openFileDialog.InitialDirectory = Application.StartupPath;
                if (openFileDialog.ShowDialog() != null)
                {
                    String line;
                    StreamReader fileIn = new StreamReader(openFileDialog.FileName);

                    while ((line = fileIn.ReadLine()) != null)
                        txtText.Text += line;
                    fileIn.Close();
                }
            }
            catch (Exception ex) { MessageBox.Show("Load text: " + ex); }
        }

        private void btnEncryptFile_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + PlayFair.PlayFairEncrypt(PlayFair.PlayFairConvertSanitizeText(line), PlayFair.PlayFairConvertSanitizeKey(txtKey.Text)));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }

        private void frmPlayFairEncrypt_Load(object sender, EventArgs e)
        {
            txtKey.Text = "First amendament!";
            txtText.Text = "Congress shall make no law respecting an establishment of religion, or prohibiting the free exercise thereof; or abridging the freedom of speech, or of the press; or the right of the people peaceably to assemble, and to petition the government for a redress of grievances.";
         
            openFileDialog.FileName = "PlayFairEncryptInput.txt";
            saveFileDialog.FileName = "PlayFairEncryptOutput.txt";
        }
    }

    public static class PlayFair
    {

        #region MODULAR_PlayFair_ALGORITHM

        public static string PlayFairEncrypt(string s, string key)
        {
            string sE = "";

            int i = 0, j = 0, k = 0, aux = 0;
            int i1 = 0, j1 = 0, i2 = 0, j2 = 0;
            int[,] m = new int[5, 5];


            for (i = 0; i < 5; i++)
                for (j = 0; j < 5; j++)
                    m[i, j] = (int)key[k++];

            for (k = 0; k < s.Length - 1; k += 2)
            {
                for (i = 0; i < 5; i++)
                    for (j = 0; j < 5; j++)
                    {
                        if ((int)s[k] == m[i, j])
                        { i1 = i; j1 = j; }
                        if ((int)s[k + 1] == m[i, j])
                        { i2 = i; j2 = j; }
                    }
                //The same line
                if (i1 == i2)
                {
                    if (j1 == 4) j1 = 0;
                    else j1++;
                    if (j2 == 4) j2 = 0;
                    else j2++;
                }
                //The same column
                else if (j1 == j2)
                {
                    if (i1 == 4) i1 = 0;
                    else i1++;
                    if (i2 == 4) i2 = 0;
                    else i2++;
                }
                // Different line and column numbers
                else
                {
                    aux = j1;
                    j1 = j2;
                    j2 = aux;
                }
                sE += (char)m[i1, j1]; sE += (char)m[i2, j2];
            }
            return sE;
        }

        public static string PlayFairDecrypt(string s, string key)
        {
            string sE = "";

            int i = 0, j = 0, k = 0, aux = 0;
            int i1 = 0, j1 = 0, i2 = 0, j2 = 0;
            int[,] m = new int[5, 5];


            for (i = 0; i < 5; i++)
                for (j = 0; j < 5; j++)
                    m[i, j] = (int)key[k++];

            for (k = 0; k < s.Length - 1; k += 2)
            {
                for (i = 0; i < 5; i++)
                    for (j = 0; j < 5; j++)
                    {
                        if ((int)s[k] == m[i, j])
                        { i1 = i; j1 = j; }
                        if ((int)s[k + 1] == m[i, j])
                        { i2 = i; j2 = j; }
                    }
                //The same line
                if (i1 == i2)
                {
                    if (j1 == 0) j1 = 4;
                    else j1--;
                    if (j2 == 0) j2 = 4;
                    else j2--;
                }
                //The same column
                else if (j1 == j2)
                {
                    if (i1 == 0) i1 = 4;
                    else i1--;
                    if (i2 == 0) i2 = 4;
                    else i2--;
                }
                // Different line and column numbers
                else
                {
                    aux = j1;
                    j1 = j2;
                    j2 = aux;
                }
                sE += (char)m[i1, j1]; sE += (char)m[i2, j2];
            }
            s = "";
            for (i = 0; i < sE.Length; i++)
            {
                if ((i - 1 >= 0) && (i + 1 < sE.Length) && (sE[i] == 'X') && (sE[i - 1] == sE[i + 1]))
                { ; }
                else { s += sE[i]; }
            }

            return s;
        }

        public static string PlayFairConvertSanitizeKey(string s)
        {

            // 4.Cheie: "First Amendment" => “FIRST AMEND”; Completare matrice de criptare [vector] fara litera 'J': cheia apoi literele alfabetului ramase, in ordine.

            String sE = "";
            int i = 0, j = 0;
            bool letterFound = false;

            s = s.ToUpper();
            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]
            // Replace 'J' with 'I'
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    if (s[i] == 'J')
                        sE += 'I';
                    else
                        sE += s[i];

            // Build cipher matrix:
            // F I R S T
            // A M E N D
            // B C G H K
            // L O P Q U
            // V W X Y Z


            s = "";
            for (i = 0; i < sE.Length; i++)
            {
                letterFound = false;
                for (j = 0; j < s.Length; j++)
                    if (s[j] == sE[i])
                    {
                        letterFound = true;
                        break;
                    }
                if (letterFound == false)
                    s += sE[i];
            }


            for (i = (int)'A'; i <= (int)'Z'; i++)
            {
                if (i != (int)'J')
                {
                    letterFound = false;
                    for (j = 0; j < s.Length; j++)
                        if (s[j] == (char)i)
                        {
                            letterFound = true;
                            break;

                        }
                    if (letterFound == false)
                        s += (char)i;
                }
            }
            //MessageBox.Show("Key:" + s + "      " + s.Length);
            return s;
        }

        public static string PlayFairConvertSanitizeText(string s)
        {

            // 1.Doar litere de la A la Z. Majuscule; Inlocuire 'J' cu 'I'; Impartire in grupuri de 2 litere; 
            // 2.Inserare 'X' intre dubluri de litere: FR EE DO M => FR EX ED OM; DD D => DX DZ D; Obs! pentru SS din grupul ES SO nu a fost folosite 'X' sau 'Z': cei doi S nu fac parte din acelasi grup de doua litere.
            // 3.Pentru numar impar de litere, adaugare o litera oarecare pentru a fi par.
            // 4.Cheie: "First Amendment" => “FIRST AMEND”; Completare matrice de criptare [vector] fara litera 'J': cheia apoi literele alfabetului ramase, in ordine.


            String sE = "";
            int i;

            s = s.ToUpper();
            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]
            // Replace 'J' with 'I'
            for (i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    if (s[i] == 'J')
                        sE += 'I';
                    else
                        sE += s[i];

            s = "";
            // ! OBS: Nu este considerat in algoritm si cazul in care trei litere sunt identice: Nu este un caz des/intalnit;
            i = 0;
            while (i < sE.Length -1)
            {
                s += sE[i];
                if (sE[i] == sE[i + 1])
                {
                    s += 'X';
                    i++;
                }
                else
                {
                    s += sE[i + 1];
                    i = i + 2;
                }
            }
            if (s.Length % 2 != 0)
                s += 'X';
            return s;
        }

        #endregion






    } // End class PlayFair









}
