﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L3_ADFGVXAlgorithm
{
    public partial class frmADFGVXDecrypt : Form
    {
        public frmADFGVXDecrypt()
        {
            InitializeComponent();
        }

        private void frmADFGVXDecrypt_Load(object sender, EventArgs e)
        {
            txtKey1.Text = "orange";
            txtKey2.Text = "water";
            txtText.Text = "DFAAVDGVFAVDAVAAVAFVDAADD";
            openFileDialog.FileName = "ADFGVXDecryptInput.txt";
            saveFileDialog.FileName = "ADFGVXDecryptOutput.txt";
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            
            txtTextEncrypted.Text = ADFGVX.Decrypt(txtText.Text, txtKey1.Text, txtKey2.Text);

            txtMatrix.Text = ADFGVX.matrixToString(ADFGVX.matrix7x7);
            txtTranspositionMatrix.Text = ADFGVX.matrixToString(ADFGVX.transpositionMatrix);
            txtTranspositionMatrixOrdered.Text = ADFGVX.matrixToString(ADFGVX.transpositionMatrixOrdered);
   
        }

        private void btnLoadText_Click(object sender, EventArgs e)
        {
            txtText.Text = "";
            try
            {
                openFileDialog.InitialDirectory = Application.StartupPath;
                if (openFileDialog.ShowDialog() != null)
                {
                    String line;
                    StreamReader fileIn = new StreamReader(openFileDialog.FileName);

                    while ((line = fileIn.ReadLine()) != null)
                        txtText.Text += line;
                    fileIn.Close();
                }
            }
            catch (Exception ex) { MessageBox.Show("Load text: " + ex); }
        }

        private void btnDecryptFile_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + ADFGVX.Decrypt(line, txtKey1.Text, txtKey2.Text));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
     
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }
        
        


    }
}
