﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L4_HomophonicAlgorithm
{
    public partial class frmHomophonicDecrypt : Form
    {
        public frmHomophonicDecrypt()
        {
            InitializeComponent();
        }

        private void frmHomophonicDecrypt_Load(object sender, EventArgs e)
        {

            String s = "";
            String nl = Environment.NewLine;
            int[][] m = Homophonic.m;

            for (int i = 0; i < m.GetLength(0); i++)
            {
                s += "" + (char)m[i][0] + "   ";
                for (int j = 1; j < m[i].Length; j++)
                    s += "" + m[i][j] + " ";
                s += nl;
            }
            txtLookupTable.Text = s;
            txtText.Text = "447549123025012620127449";

            openFileDialog.FileName = "HomophonicEncrypted.txt";
            saveFileDialog.FileName = "HomophonicDecrypted.txt";
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            txtTextEncrypted.Text = Homophonic.Decrypt(txtText.Text);
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }

        private void btnDecryptFile_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("OPEN FILE: Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("SAVE FILE: Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + Homophonic.Decrypt(line));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
 
        }
    }
}
