﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L4_HomophonicAlgorithm
{
    public partial class frmHomophonicEncrypt : Form
    {
        public frmHomophonicEncrypt()
        {
            InitializeComponent();
        }

        private void frmHomophonicEncrypt_Load(object sender, EventArgs e)
        {
            String s = "";
            String nl = Environment.NewLine;
            int[][] m = Homophonic.m;

            for (int i = 0; i < m.GetLength(0); i++)
            {
                s += "" + (char)m[i][0] + "   ";
                for (int j = 1; j < m[i].Length; j++)
                    s += "" + m[i][j] + " ";
                s += nl;
            }
            txtLookupTable.Text = s;


            txtText.Text = "cryptography";
            // MessageBox.Show("Lookup table 00 - 99 Accuracy: " + Homophonic.VerifyLookupTable00_99Accuracy());
            // MessageBox.Show("Lookup table Duplicate Accuracy: " + Homophonic.VerifyLookupTableDuplicateAccuracy());

            openFileDialog.FileName = "input.txt";
            saveFileDialog.FileName = "HomophonicEncrypted.txt";

        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            String s = "";
            String text = Homophonic.Encrypt(txtText.Text);
            for (int i = 0; i < text.Length; i = i + 2)
                s += "" + text[i] + text[i + 1] + " ";
            txtGroupedText.Text = s;
            txtTextEncrypted.Text = text;
        }

        private void btnEncryptFile_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("OPEN FILE: Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("SAVE FILE: Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + Homophonic.Encrypt(line));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
 
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }
    }

    #region HomophonicAlgorithm
    //Litera  Numere                             Litera  Numere      Litera Numere
    //E 12    00,06,13,32,52,53,71,72,83,93,94   D 3     05,29,66    B 2 48,97
    //T 10    14,16,30,31,43,58,73,79,84         U 3     07,22,91    V 1 99
    //O 8     11,15,25,41,42,57,78,85            C 3     23,44,92    K 1 67
    //I 8     03,10,34,35,54,56,77,86            M 3     33,51,80    X 1 47
    //A 8     18,19,20,36,55,62,76,87            P 2     12,50       J 1 95
    //N 7     02,37,38,59,61,69,70               Y 2     49,68       Q 1 90
    //R 6     09,26,39,60,75,88                  F 2     24,45       Z 1 46
    //H 5     17,28,63,74,89                     G 2     01, 96
    //L 4     04,08,27,64                        W 2     81,98

    //    Verificaţi dacă "cryptography" se criptează la: 440968123085962655122749.
    //    Decriptaţi: 792793 087851785004116993 923512649360 922069 9772 66932342663205.

    #endregion

    public static class Homophonic
    {

        public static int[][] m = new int[26][] {
                new int[]{(int)'E', 0,6,13,32,52,53,71,72,83,93,94},
                new int[]{(int)'T', 14,16,30,31,43,58,73,79,84},
                new int[]{(int)'O', 11,15,25,41,42,57,78,85},
                new int[]{(int)'I', 3,10,34,35,54,56,77,86},
                new int[]{(int)'A', 18,19,20,36,55,62,76,87},
                new int[]{(int)'N', 2,37,38,59,61,69,70},
                new int[]{(int)'R', 9,26,39,60,75,88},
                new int[]{(int)'S', 21, 40, 65, 82},
                new int[]{(int)'H', 17,28,63,74,89},
                new int[]{(int)'L', 4,8,27,64},
                new int[]{(int)'D', 5,29,66},
                new int[]{(int)'U', 7,22,91},
                new int[]{(int)'C', 23,44,92},
                new int[]{(int)'M', 33,51,80},
                new int[]{(int)'P', 12,50},
                new int[]{(int)'Y', 49,68},
                new int[]{(int)'F', 24,45},
                new int[]{(int)'G', 1, 96},
                new int[]{(int)'W', 81,98},
                new int[]{(int)'B', 48,97},
                new int[]{(int)'V', 99},
                new int[]{(int)'K', 67},
                new int[]{(int)'X', 47},
                new int[]{(int)'J', 95},
                new int[]{(int)'Q', 90},
                new int[]{(int)'Z', 46}
            };

        public static String VerifyLookupTable00_99Accuracy()
        {
            String s = "";
            int i, j, k;
            bool found = false;

            for (k = 0; k < 100; k++)
            {
                found = false;
                for (i = 0; i < m.GetLength(0); i++)
                {

                    for (j = 1; j < m[i].Length; j++)
                    {
                        if (k == m[i][j])
                        {
                            found = true;
                            break;
                        }
                    }

                }
                if (found == false)
                { s += "" + k + " "; }
            }
            //MessageBox.Show(s);
            return s; //Text representing numbers form from 00 to 99 that are not included;
        }
        public static String VerifyLookupTableDuplicateAccuracy()
        {
            String s = "";
            int i, j, k, count;

            for (k = 0; k < 100; k++)
            {
                count = 0;
                for (i = 0; i < m.GetLength(0); i++)
                {

                    for (j = 1; j < m[i].Length; j++)
                    {
                        if (k == m[i][j])
                        {
                            count++;
                        }
                    }

                }
                if (count > 1)
                { s += "" + k + " "; }
            }
            //MessageBox.Show(s);
            return s; // Duplicated numbers
        }
        public static string KeepOnlyLetters(string s)
        {
            String sE = "";
            s = s.ToUpper();

            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]
            for (int i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE += s[i];

            return sE;
        }
        public static String Decrypt(String text)
        {
            String s = "";
            String sNr = "";
            int i, j, k;
            int nr = 0;
            int letter=0;
            try
            {
                for (k = 0; k < text.Length; k = k + 2)
                {
                    sNr = "" + text[k] + "" + text[k + 1];
                    nr = Convert.ToInt16(sNr);
                    for (i = 0; i < m.GetLength(0); i++)
                    {
                        for (j = 1; j < m[i].Length; j++)
                            if (nr == m[i][j])
                            {
                                letter = m[i][0];
                                break;
                            }
                    }
                    s += (char)letter;
                }
            }
            catch (Exception e) { MessageBox.Show("Exception" + e); }

            return s;

        }

        public static String Encrypt(String text)
        {
            String s = "";
            int i, k, index;
            int nr = 0;
            Random obRnd = new Random();
            text = KeepOnlyLetters(text);

            // MessageBox.Show(s);
            for (k = 0; k < text.Length; k++)
            {
                //nr = -1;
                for (i = 0; i < m.GetLength(0); i++)
                {

                    if (text[k] == (char)m[i][0])
                    {
                        index = obRnd.Next(1, m[i].Length - 1);
                        nr = m[i][index];
                        break;
                    }

                }
                // if (nr != -1)
                if ((nr >= 0) && (nr <= 9))
                    s += "0" + nr;
                else
                    s += nr;
            }

            return s;

        }


    } // end class Homophonic
}
