﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L5_ACAHomophonicAlgorithm
{
    public partial class frmACAHomophonicDecrypt : Form
    {
        public frmACAHomophonicDecrypt()
        {
            InitializeComponent();
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            String s = txtText.Text;
            String ss = "";
            String matrix = ACAHomophonic.matrixToString(ACAHomophonic.BuildEncryptionMatrix(txtKey.Text));
            String matrixTransposed = ACAHomophonic.matrixTransposedToString(ACAHomophonic.BuildEncryptionMatrix(txtKey.Text));
            String text = ACAHomophonic.Decrypt(txtText.Text, txtKey.Text);
            String nl = Environment.NewLine;

            for (int i = 0; i < s.Length - 1; i = i + 2)
                ss += "" + s[i] + s[i + 1] + " ";
            txtGroupedText.Text = ss;


                txtLookupTable.Text = matrix + nl + nl + matrixTransposed;
            txtTextEncrypted.Text = text;
        }

        private void btnDecryptFile_Click(object sender, EventArgs e)
        {
            String key = txtKey.Text;

            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("OPEN FILE: Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("SAVE FILE: Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + ACAHomophonic.Decrypt(line, key));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
        }



        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }

        private void frmACAHomophonicDecrypt_Load(object sender, EventArgs e)
        {
            openFileDialog.FileName = "HomophonicEncrypted.txt";
            saveFileDialog.FileName = "HomophonicDecrypted.txt";

            txtKey.Text = "this";
            txtText.Text = "60611290845532740008227566";
        }
    }
}
