﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSI_L6_EnigmaAlgorithm
{
    public partial class frmEnigmaDecrypt : Form
    {
        public frmEnigmaDecrypt()
        {
            InitializeComponent();
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            txtTextEncrypted.Text = Enigma.Encrypt(txtText.Text, txtReflector.Text);
              }

        private void frmEnigmaDecrypt_Load(object sender, EventArgs e)
        {
            String s = "";
            String nl = Environment.NewLine;
            txtReflector.Text = "B";
            txtText.Text = "WJDASOKFAKOBMLFUKOJDKLBJAFWQBMDFDMBKJMXGFWDKSDPWJIWFZDAFZBSGDTJDSBLJARWZUW";

            openFileDialog.FileName = "EnigmaEncrypted.txt";
            saveFileDialog.FileName = "EnigmaDecrypted.txt";



            // MessageBox.Show(""+Enigma.rotor[0][0]);

            for (int i = 0; i < Enigma.rotor.Length; i++)
            {
                for (int j = 0; j < Enigma.rotor[i].Length; j++)
                    s += "" + Enigma.rotor[i][j] + " ";
                s += nl;
            }
            s += nl + nl;

            for (int i = 0; i < Enigma.reflector.Length; i++)
            {
                for (int j = 0; j < Enigma.reflector[i].Length; j++)
                    s += "" + Enigma.reflector[i][j] + " ";
                s += nl;
            }

            txtLookupTable.Text = s;
        }

        private void btnDecryptFile_Click(object sender, EventArgs e)
        {
            String RelfectorType = txtReflector.Text;

            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("OPEN FILE: Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("SAVE FILE: Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + Enigma.Encrypt(line, RelfectorType));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }
    }
}
