﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;


namespace CSI_L6_EnigmaAlgorithm
{
    public partial class frmEnigmaEncrypt : Form
    {
        public frmEnigmaEncrypt()
        {
            InitializeComponent();
        }

        private void frmEnigmaEncrypt_Load(object sender, EventArgs e)
        {
            String s="";
            String nl = Environment.NewLine;
            txtReflector.Text = "B";
            txtText.Text = "I couldn't understand consecutive rotor encryption logic without help of Colescu Mihai.";

            openFileDialog.FileName = "input.txt";
            saveFileDialog.FileName = "EnigmaEncrypted.txt";



           // MessageBox.Show(""+Enigma.rotor[0][0]);

            for (int i = 0; i < Enigma.rotor.Length; i++)
            {
                for (int j = 0; j < Enigma.rotor[i].Length; j++)
                    s += "" + Enigma.rotor[i][j] + " ";
                s += nl;
            }
            s += nl + nl;

            for (int i = 0; i < Enigma.reflector.Length; i++)
            {
                for (int j = 0; j < Enigma.reflector[i].Length; j++)
                    s += "" + Enigma.reflector[i][j] + " ";
                s += nl;
            }

            txtLookupTable.Text = s;
        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {

            txtTextEncrypted.Text = Enigma.Encrypt(txtText.Text, txtReflector.Text);
        }

        private void btnOpenFolder_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath);
        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void btnEncryptFile_Click(object sender, EventArgs e)
        {
            String RelfectorType = txtReflector.Text;

            openFileDialog.InitialDirectory = Application.StartupPath;
            saveFileDialog.InitialDirectory = Application.StartupPath;
            MessageBox.Show("OPEN FILE: Please select a text file in next appearing window:");
            if (openFileDialog.ShowDialog() != null)
            {
                MessageBox.Show("SAVE FILE: Please specify the name of the encrypted file in the next appearing window:");
                if (saveFileDialog.ShowDialog() != null)
                    try
                    {
                        String line;
                        StreamReader fileIn = new StreamReader(openFileDialog.FileName);
                        StreamWriter fileOut = new StreamWriter(saveFileDialog.FileName, false);
                        while ((line = fileIn.ReadLine()) != null)
                            fileOut.WriteLine("" + Enigma.Encrypt(line, RelfectorType));
                        fileIn.Close(); fileOut.Close();
                    }

                    catch (Exception ex) { MessageBox.Show("Save text: " + ex); }

            }
        }
        
    }


    #region Enigma Algorithm


    /*
  
Algorithm implemented with help of colleague Colescu Mihai.      
     
INPUT A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
Rotor I E K M F L G D Q V Z N T O W Y H X U S P A I B R C J
Rotor II A J D K S I R U X B L H W T M C Q G Z N P Y F V O E
Rotor III B D F H J L C P R T X V Z N Y E I W G A K M U S Q O
    
reflector B (AY) (BR) (CU) (DH) (EQ) (FS) (GL) (IP) (JX) (KN) (MO) (TZ) (VW)
reflector C (AF) (BV) (CP) (DJ) (EI) (GO) (HY) (KR) (LZ) (MX) (NW) (TQ) (SU) 
  
     
     */

    #endregion

    public static class Enigma
    {
        static int alphabetIndex = 0;
       public  static String[] rotor = new String[] {
            /*ALPHABET*/ "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 
            /*ROTOR I*/  "EKMFLGDQVZNTOWYHXUSPAIBRCJ",
            /*ROTOR II*/ "AJDKSIRUXBLHWTMCQGZNPYFVOE",
            /*ROTOR III*/"BDFHJLCPRTXVZNYEIWGAKMUSQO"};

        public static String[] reflector = new String[] {
            /*REFLECTOR B*/"AYBRCUDHEQFSGLIPJXKNMOTZVW",
            /*REFLECTOR C*/"AFBVCPDJEIGOHYKRLZMXNWTQSU"};

        public static String KeepOnlyLetters(string s)
        {
            String sE = "";
            s = s.ToUpper();

            // Trim: white spaces, number, small leters, ... : Trim all but letter in [A B ... Z]
            for (int i = 0; i < s.Length; i++)
                if (((int)s[i] >= (int)'A') && ((int)s[i] <= (int)'Z'))
                    sE += s[i];

            return sE;
        }
        public static String Rotor(String text, int rotorNumber)
        {
            String s = "";
            int i, j;

            for (i = 0; i < text.Length; i++)
                for (j = 0; j < rotor[alphabetIndex].Length; j++)
                    if (text[i] == rotor[alphabetIndex][j])
                        s += rotor[rotorNumber][j];
            return s;
        }
        public static String RotorAfterReflect(String text, int rotorNumber)
        {
            String s = "";
            int i, j;

            for (i = 0; i < text.Length; i++)
                for (j = 0; j < rotor[rotorNumber].Length; j++)
                    if (text[i] == rotor[rotorNumber][j])
                        s += rotor[alphabetIndex][j];
            return s;
        }
        public static String Reflector(String text, int reflectorNumber)
        {
            String s = "";
            int i, j;

            for (i = 0; i < text.Length; i++)
                for (j = 0; j < reflector[reflectorNumber].Length; j++)
                    if (text[i] == reflector[reflectorNumber][j])
                        if (j % 2 == 0)
                            s += reflector[reflectorNumber][j + 1];
                        else
                            s += reflector[reflectorNumber][j - 1];
            return s;
        }
        public static String Encrypt(String text, String reflectorType)
        {
            text = text.ToUpper();
            text = KeepOnlyLetters(text);

            String s = "";
            String Rotor3 = Rotor(text, 3);
            String Rotor2 = Rotor(Rotor3, 2);
            String Rotor1 = Rotor(Rotor2, 1);
            String Reflected = "";

            int reflectorB = 0, reflectorC = 1;

            if (reflectorType == "B")
                Reflected = Reflector(Rotor1, reflectorB);
            else if (reflectorType == "C")
                Reflected = Reflector(Rotor1, reflectorC);

            Rotor1 = RotorAfterReflect(Reflected, 1);
            Rotor2 = RotorAfterReflect(Rotor1, 2);
            s = RotorAfterReflect(Rotor2, 3);

            return s;
        }

    } // end class Enigma
}
